/*
Victor Ng
vn6216@albany.edu
csi402 Spring 2006

*/


#include <stdio.h>
#include <stdlib.h>

#include "astruct_def.h"
#include "aconstants.h"


void readdata ( FILE * finp )
{
  Node node[MAXPKS];
  int array[MAXPKS];
  
  unsigned char byte; /* store for first byte read */
  int pkPL; /* store for payload size */
  unsigned char bitval; /* store for significant bit */
  unsigned char pkID; /* store for packet id */
  unsigned char temp; /* temp variable */
  
  int pkcount = 0; /* packet counter */
  int i = 0; /* counter */
  int j = 0; /* counter */
  int k = 0; /* counter */
  
  int largepl = 0; /* largest payload */
  int largeid = 0; /* largest packet id */
  int tmp1, tmp2; /* use for sorting */
  
  fseek(finp, 0L,SEEK_SET);
  /* reading the file */
  while (fread ( &byte , sizeof(char), 1, finp) )/* read 8 bits aka 1 byte */
  {
    bitval = byte >> 7; /* Look at most significant bit */
    bitval = bitval & 0x01;  /* combine with mask to get starting bit*/
    pkPL=byte-0;
    
    if (bitval == 0) /* if significant bit = 0 */
    { /* it's a data packet */
      /* fread ( &pkPL, PLSIZE, 1, finp); */
      fread ( &pkID, sizeof(char), 1, finp); /* read the packet ID */
      node[i].spkid = pkID - 0; /* storing packet ID */
      node[i].splsz = byte - 0; /* storing payload size */  
      /* skipping forward by Payload size */
      while (pkPL > 0 && fread( &temp, sizeof(char), 1, finp))
      pkPL--; /* repeat until the payload is read */
      pkcount++; /* increment packet counter */
      i++;
    }
    else
    { /* it's a control packet */
      fread ( &pkID, sizeof(char), 1, finp); /* skipping packet */
    };
  };
  /* end of file, now to output */
  if ( pkcount == 0 ) 
  { /* no data packets read */
    printf( "The input file does not have any Data Packets.\n");
  }
  else
  { /* data packets exists, proceed with output */
    printf( "Information about Data Packets: \n");
    
    /* search for largest packet */
    i = 0;/* reset counter i */
    while (i < pkcount)
    { /* there are still packets in the struct */
      if (largepl < node[i].splsz) /* compare the payload */
        largepl = node[i].splsz; /* store the payload */
      i++; /* increment i */
    }; i = 0; /* reset counter i */
    /* search for largest id */
    while (i < pkcount)
    { /* there are still packets in the struct */
      if (largeid < node[i].spkid) /* compare the id */
        largeid = node[i].spkid; /* store the id */
      i++; /* increment i */
    }; i = 0; /* reset counter i */
    
    printf("Number of packets    = %d \n", pkcount);
    printf("Largest packet ID    = %d \n", largeid);
    printf("Largest payload size = %d \n", largepl);
    printf("Missing packet IDs: ");
/* sorting the struct */
    for(i = 0; i < pkcount-1; i++)           /*   */
    {                                        /* B */
      for(j = 0; j < pkcount-1-i; j++)       /* U */
      {                                      /* B */
        if(node[j+1].spkid < node[j].spkid)  /* B */
        {                                    /* L */
          tmp1 = node[j].spkid;              /* E */
          tmp2 = node[j].splsz;              /*   */
          node[j].spkid = node[j+1].spkid;   /* S */
          node[j].splsz = node[j+1].splsz;   /* O */
          node[j+1].spkid = tmp1;            /* R */
          node[j+1].splsz = tmp2;            /* T */
        }                                    /*   */
      };
    };/* end sort */
        
    j=0;i=0;k=0; /* reset counters */
    tmp2 = 0; /* tmp2 is flag for printing ','*/
    while (i < pkcount)
    { /* while there are nodes to be processed */
      tmp1 = node[i].spkid; /* read the first id */
      while (j < tmp1) 
      { /* if the id is less than j */
        array[k]=j; /* put j into an array for first in first out */
        j++; k++; /*increment counters */
      };
      if (j == tmp1) /* process j for next loop */
        j=tmp1+1;
      if (k > 2) 
      { /* if array size is 3 or more */
        if (tmp2==1) printf(","); /* print ',' if flag = 1 */
        printf(" %d-%d", array[0], array[k-1]); /* print id's in range */
        tmp2=1; /* set flag to 1 for printing comma */
      }
      else if (k == 2)
      { /* if array size is == 2 */
        if (tmp2==1) printf(","); /* print ',' if flag = 1 */
        printf(" %d, %d", array[0], array[1]); /* print the two id's */
        tmp2=1; /* set flag to 1 for printing comma */
      }
      else
        ; /* do nothing, array size is too small */
      k=0; /* reset k */
      i++; /* increment i */
    };/* no more nodes in struct */
    printf(" \n"); /* line return */
  };
  printf(" \n");   /* newline to finish the output */
};

void readcontrol ( FILE * finp )
{
  Node node[MAXPKS];
  int array[MAXPKS];
  
  unsigned char byte; /* store for first byte read */
  int pkPL; /* store for payload size */
  unsigned char bitval; /* store for significant bit */
  unsigned char pkID; /* store for packet id */
  unsigned char temp; /* temp variable */
  
  int pkcount = 0; /* packet counter */
  int i = 0; /* counter */
  int j = 0; /* counter */
  int k = 0; /* counter */

  int largeid = 0; /* largest packet id */
  int tmp1, tmp2; /* use for sorting */
  
  fseek(finp, 0L,SEEK_SET); 
  /* reading the file */
  while (fread ( &byte , sizeof(char), 1, finp) )/* read 8 bits aka 1 byte */
  {
    bitval = byte >> 7; /* Look at most significant bit */
    bitval = bitval & 0x01;  /* combine with mask to get starting bit*/
    pkPL=byte-0;
    
    if (bitval == 0) /* if significant bit = 0 */
    { /* it's a data packet */
      /* fread ( &pkPL, PLSIZE, 1, finp); */
      fread ( &pkID, sizeof(char), 1, finp); /* read the packet ID */
      /* skipping forward by Payload size */
      while (pkPL > 0 && fread( &temp, sizeof(char), 1, finp))
      pkPL--; /* repeat until the payload is read */
    }
    else
    { /* it's a control packet */
      fread ( &pkID, sizeof(char), 1, finp); /* skipping packet */
      node[i].spkid = pkID - 0; /* storing packet ID */
      node[i].splsz = 0; /* setting payload size = zero */ 
      pkcount++; /* increment packet counter */
      i++;
    };
  };
  /* end of file, now to output */
  if ( pkcount == 0 ) 
  { /* no data packets read */
    printf( "The input file does not have any Control Packets. \n");
  }
  else
  { /* data packets exists, proceed with output */
    printf( "Information about Control Packets: \n");

    /* search for largest id */
    i = 0;/* reset counter i */ 
    while (i < pkcount)
    { /* there are still packets in the struct */
      if (largeid < node[i].spkid) /* compare the id */
        largeid = node[i].spkid; /* store the id */
      i++; /* increment i */
    }; i = 0; /* reset counter i */
    
    printf("Number of packets    = %d \n", pkcount);
    printf("Largest packet ID    = %d \n", largeid);
    printf("Missing packet IDs: ");
/* sorting the struct */
    for(i = 0; i < pkcount-1; i++)           /*   */
    {                                        /* B */
      for(j = 0; j < pkcount-1-i; j++)       /* U */
      {                                      /* B */
        if(node[j+1].spkid < node[j].spkid)  /* B */
        {                                    /* L */
          tmp1 = node[j].spkid;              /* E */
          node[j].spkid = node[j+1].spkid;   /*   */
          node[j+1].spkid = tmp1;            /* S */
          node[j+1].spkid = tmp1;            /* O */
        }                                    /* R */
      };                                     /* T */
    };/* end sort */
        
    j=0;i=0;k=0; /* reset counters */
    tmp2 = 0; /* tmp2 is flag for printing ','*/
    while (i < pkcount)
    { /* while there are nodes to be processed */
      tmp1 = node[i].spkid; /* read the first id */
      while (j < tmp1) 
      { /* if the id is less than j */
        array[k]=j; /* put j into an array for first in first out */
        j++; k++; /*increment counters */
      };
      if (j == tmp1) /* process j for next loop */
        j=tmp1+1;
      if (k > 2) 
      { /* if array size is 3 or more */
        if (tmp2==1) printf(","); /* print ',' if flag = 1 */
        printf(" %d-%d", array[0], array[k-1]); /* print id's in range */
        tmp2=1; /* set flag to 1 for printing comma */
      }
      else if (k == 2)
      { /* if array size is == 2 */
        if (tmp2==1) printf(","); /* print ',' if flag = 1 */
        printf(" %d, %d", array[0], array[1]); /* print the two id's */
        tmp2=1; /* set flag to 1 for printing comma */
      }
      else
        ; /* do nothing, array size is too small */
      k=0; /* reset k */
      i++; /* increment i */
    };/* no more nodes in struct */
    printf(" \n"); /* line return */
  };
  printf(" \n");   /* newline to finish the output */
};





