/*
Victor Ng
vn6216@albany.edu
csi402 Spring 2006

*/


#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>

#include "bprototype.h"
#include "bconstants.h"
/*#include "bstruct_def.h"*/
/*#include "bfunctions.c"*/


int main(int argc, char *argv[]) 
{
/* pointers to commands for use with 'strcmp' */
static const char * LISTREL  = "listrel";   /* the listrel command */
static const char * SCHEMA   = "schema";    /* the schema command */
static const char * QUERY    = "query";     /* the query command */
static const char * QUIT     = "quit";      /* the quit command */
static const char * HELP     = "help";      /* the help command */
static const char * WC       = "*";         /* the wildcard command */
    
    
    FILE * finp; /* pointer to file to be read */
    relT rTABLE[MAXREL-1]; /* relations table */
    int relations, numattr; /* temporary storage */
    int i=0, j=0, k=0; /* counters */
    char cmd[MAXCMD]; /* for reading the command */
    char cmd1[MAXLEN],cmd2[MAXLEN],cmd3[MAXLEN];
    
    
    ptrAT * paTABLE;
    ptrRT * prTABLE;
    *prTABLE = rTABLE;
      
        
    /* check for command line argument having right amount of arguments */
    if ( (argc == NUMARG) )
    ;
    else
    {   /* number of arguments or commands are not correct */
        fprintf(stderr, "Invalid number of arguments. \n");  /* prints error message */
        exit(1); /* exit due to incorrect number of arguments */
    };

        if ( (finp = fopen(argv[1], "r")) == NULL ) 
        {   /* open failed */
            fprintf(stderr, "Could not open file '%s' for reading. \n", argv[1]); /* prints error */
            exit(1); /*exit due to failure in opening the file */
        };
  

relations = readfile(prTABLE,finp);

/* debug */
i=0, j=0, k=0; /* reset counters */
  while (i < relations)
  {
printf("%s ", prTABLE[i]->relname);
printf("%d ", prTABLE[i]->relsize);
printf("%s \n", prTABLE[i]->bfname);    
    j=0;
    while (j < numattr)
    {
paTABLE = prTABLE[i]->paT;
printf("%s ", paTABLE[j]->attrname);
printf("%s ", &paTABLE[j]->attrtype);
printf("%d \n", paTABLE[j]->attrsize);
      j++;
    };
    i++;
  };
/* debug */
/* start of menu */
do
{
  i=0, j=0, k=0; /* reset counters */
  printf("p1b> ");   /* print prompt */
  scanf("%s", cmd);  /* get user input */
  
  if (strcmp( cmd, LISTREL ) == 0 ) 
  { /* cmd is listrel */
    while (i < relations)
    { /* loop thru relations table */
      printf(" %s \n", prTABLE[i]->relname);  /* print name */
      i++; /* increment counter */
    };/* end of loop */  
  }
  else if (strcmp( cmd, SCHEMA ) == 0 )
  { /* cmd is schema */
    printf( "   relation: "); /* print prompt */
    scanf("%s", cmd1); /*get use input */
    if (strcmp( cmd1, WC ) == 0 )
    { /* if wildcard */
      while (i < relations) /* loop thru relations */
      {
        printf(" %s ", prTABLE[i]->relname); /* print relation name */
        printf(" %d ", prTABLE[i]->relsize); /* print relation size */
        printf(" %s \n", prTABLE[i]->bfname);  /* print data file */
        j=0; /* reset counter */
        while (j < numattr) /* loop thru attrubutes */
        {
          paTABLE = prTABLE[i]->paT;
          printf(" %s ", paTABLE[j]->attrname); /* print attribute name */
          printf(" %s ", &paTABLE[j]->attrtype); /* print attribute type */
          printf(" %d \n", paTABLE[j]->attrsize); /* print attribute size */
          j++; /*increment attributes */
        };/* end of attribute loop */
      i++; /* increment relations */
      }; /* end of relations loop */
    }
    else
    {
      while (i < relations && k !=1 ) /* loop thru relations */ /* k is flag for found relations */
      {
        strcpy(cmd2, prTABLE[i]->relname); /* get relations name */
        if (strcmp( cmd1, cmd2 ) == 0) 
        { /* relations name match */
          k=1; /* setting flag for found relations */
          printf(" %s ", prTABLE[i]->relname); /* print relation name */
          printf(" %d ", prTABLE[i]->relsize); /* print relation size */
          printf(" %s \n", prTABLE[i]->bfname);  /* print data file */
          j=0; /* reset counter */
          while (j < numattr) /* loop thru attrubutes */
          {
            paTABLE = prTABLE[i]->paT;
            printf(" %s ", paTABLE[j]->attrname); /* print attribute name */
            printf(" %s ", &paTABLE[j]->attrtype); /* print attribute type */
            printf(" %d \n", paTABLE[j]->attrsize); /* print attribute size */
            j++; /*increment attributes */
          };/* end of attribute loop */
        };
        i++; /*increment relations */
      };/* end of relations loop */
    }
    if (k != 1) /* if relations not found */
      printf("Cannot find relation named '%s'.\n", cmd1); /* print error msg */
  }
  else if (strcmp( cmd, QUERY ) == 0 )
  { /* cmd is query */
    printf( "   select: "); /* print prompt */
    scanf("%s", cmd1); /*get use input */
    printf( "   from: "); /* print prompt */
    scanf("%s", cmd1); /*get use input */
    printf( "   where: "); /* print prompt */
    scanf("%s", cmd1); /*get use input */
  
    
  }
  else if (strcmp( cmd, QUIT ) == 0 )
  { /* cmd is quit */
    break; /* break to end of  loop */  
  }
  else if (strcmp( cmd, HELP ) == 0 )
  { /* cmd is help */  
  }
  else 
  { /* cmd is invalid */
      printf( "Err: Invalid command '%s'. \n", cmd); /* print error */  
  };

}while ( strcmp( cmd, QUIT ) != 0 ); /* loop if cmd is not 'quit' */
printf( "Exiting on request by User. \n \n"); /* print quit msg */
return 0;/* end of program */
}
