/*
Victor Ng
vn6216@albany.edu
csi402 Spring 2006

*/


#include <stdio.h>
#include <stdlib.h>

#include "aprototype.h"
#include "aconstants.h"

/*#include "afunctions.c"*/

/* pointers to commands for use with 'strcmp' */
static const char * cCONT = "-c";   /* the control command */
static const char * cDATA = "-d";    /* the data command */
static const char * cBOTH = "-cd";    /* the control and data command */

int main(int argc, char *argv[]) 
{
    FILE * finp; /* pointer to file to be read */
    
    /* check for command line argument having right amount of arguments */
    if ( (argc == NUMARG) )
    ;
    else
    {   /* number of arguments or commands are not correct */
        fprintf(stderr, "Invalid number of arguments. \n");  /* prints error message */
        exit(1); /* exit due to incorrect number of arguments */
    };
    if ( (strcmp(argv[1], cCONT) == 0) || (strcmp(argv[1], cDATA) == 0) || (strcmp(argv[1], cBOTH) == 0) )
    ;
    else
    {   /* commands are invalid */
        fprintf(stderr, "Invalid command. \n");  /* prints error message */
        exit(1); /* exit due to invalid command */
    };

        if ( (finp = fopen(argv[2], "r")) == NULL ) 
        {   /* open failed */
            fprintf(stderr, "Could not open file '%s' for reading. \n", argv[2]); /* prints error */
            exit(1); /*exit due to failure in opening the file */
        };

    if ( strcmp(argv[1], cDATA) == 0 )
    { /* cmdflag is '-d' */
        readdata(finp); /* read data packets */
    }
    else if ( strcmp(argv[1], cCONT) == 0 )
    { /* cmdflag is '-c' */
        readcontrol(finp); /* read control packets */
    }
    else if ( strcmp(argv[1], cBOTH) == 0 )
    { /* cmdflag is '-cd' */
        readcontrol(finp); /* read control packets */
        readdata(finp); /* read data packets */
    }
    else /* the command flag is not acceptible */
    { /* should not happen */
        fprintf(stderr, "Invalid flag '%s'. \n", argv[1]);  /* prints error message */
        exit(1); /* exit due to invalid command */
    };






    return 0;
}
