/* 
Victor Ng
vn6216@albany.edu
csi402 Spring2006

*/


#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>

#include "bconstants.h"
#include "bstruct_def.h" 

void printall (int relations)
{
  int i=0,j=0; /* counters */

  i=0, j=0;/* reset counters */
  while (i < relations)
  {
    printf("%s ", rTABLE[i].relname); /* print relation name */
    printf("%d ", rTABLE[i].relsize); /* print relation size */
    printf("%s \n", rTABLE[i].bfname);  /* print data file */  
    j=0; /* reset counter */
    while (j < rTABLE[i].relsize) /* loop thru attrubutes */
    {
      printf("%s ", rTABLE[i].paT[j].attrname); /* print attribute name */
      printf("%s ", &rTABLE[i].paT[j].attrtype); /* print attribute type */
      printf("%d \n", rTABLE[i].paT[j].attrsize); /* print attribute size */
      j++; /*increment attributes */
    }; /* end of attributes loop */
    i++; /* increment relations */
  }; /* end of relations loop */
}
int readfile (FILE * finp)
{
  int relations; /* temp to hold the number of relations read */
  int i=0,j=0,k=0;; /* counters */
  fscanf( finp, "%d", &relations);
  while (i < relations)
  {
    fscanf( finp, "%s", rTABLE[i].relname); /* read relation name */
    fscanf( finp, "%d", &rTABLE[i].relsize); /* read relation size */
    fscanf( finp, "%s", rTABLE[i].bfname); /* read binary file name */
    j=0;k=0;
    while (j < rTABLE[i].relsize)
    {
      fscanf( finp, "%s", rTABLE[i].paT[j].attrname); /* read attribute name */
      fscanf( finp, "%s", &rTABLE[i].paT[j].attrtype); /* read attribute type */
      fscanf( finp, "%d", &rTABLE[i].paT[j].attrsize); /* read attribute size */
      rTABLE[i].paT[j].attrindex = k;
      k+=rTABLE[i].paT[j].attrsize;
      j++;
    };
    i++;
  };
  return relations; /* number of relations is returned */
}

void listrel (int relations)
{
  int i=0; /* counters */
  while (i < relations)
  { /* loop thru relations table */
    printf(" %s \n", rTABLE[i].relname);  /* print name */
    i++; /* increment counter */
  };/* end of loop */
}

void schema(int relations)
{
  char cmd1[MAXLEN],cmd2[MAXLEN];
  int i=0,j=0,k=0; /* counters */
  
  printf( "   relation: "); /* print prompt */
  scanf("%s", cmd1); /*get use input */
  if (strcmp( cmd1, "*" ) == 0 )
  { /* if wildcard */
    printall(relations); /* print all the relations */
  }
  else
  {
    while (i < relations && k !=1 ) /* loop thru relations */ /* k is flag for found relations */
    {
      strcpy(cmd2, rTABLE[i].relname); /* get relations name */
      if (strcmp( cmd1, cmd2 ) == 0) 
      { /* relations name match */
        k=1; /* setting flag for found relations */
        printf(" %s ", rTABLE[i].relname); /* print relation name */
        printf(" %d ", rTABLE[i].relsize); /* print relation size */
        printf(" %s \n", rTABLE[i].bfname);  /* print data file */
        j=0; /* reset counter */
        while (j < rTABLE[i].relsize) /* loop thru attrubutes */
        {
          printf(" %s ", rTABLE[i].paT[j].attrname); /* print attribute name */
          printf(" %s ", &rTABLE[i].paT[j].attrtype); /* print attribute type */
          printf(" %d \n", rTABLE[i].paT[j].attrsize); /* print attribute size */
          j++; /*increment attributes */
        };/* end of attribute loop */
      };
      i++; /*increment relations */
    };/* end of relations loop */
    if (k != 1) /* if relations not found */
      printf("Cannot find relation named '%s'.\n", cmd1); /* print error msg */
  };
}

void query (int relations)
{
  static const char * cS = "S";       /* S  */
  static const char * cI = "I";       /* I  */
  static const char * cEQT  = "==";   /* == */
  static const char * cNEQ  = "!=";   /* != */
  static const char * cGRT  = ">";    /* >  */
  static const char * cLST  = "<";    /* <  */
  static const char * cGET  = "<=";   /* <= */
  static const char * cLET  = ">=";   /* >= */
  
  char *cmd1[MAXREL],*cmd2[MAXREL],*cmd3[MAXREL];
  int i=0,j=0,k=0;/* counters */
  int cmd1count[20];
  int icount=0,jcount=0,kcount=0; 
  int flag1= -1, flag2=-1, flag3=-1; /* flags for checking if commands are valid */
  char line1[MAXCMD],line2[MAXCMD],line3[MAXCMD]; /* preproccessed cmdline */
  char attrvar[MAXCMD]; int attrvnum;
  int line1argcount, line3argcount; /* argument counters */
  char ch; /* temporary storage */
  int tuplesize;
  FILE * finp; /* pointer to file to be read */
  unsigned char temp; /* temp variable */
  
  printf( "   select: "); /* print prompt */
  i=0;
  while ( (ch = getchar())!= '\n' )
    line1[i++] = ch;
  line1[i] = '\0';    
  i=0; /* reset counters */
  cmd1[0] = strtok(line1,SEPCHARS); 
  while ( cmd1[i]!= NULL ) 
  { /* extracting the arguments */
    i++;   /* increment 'i' */
    cmd1[i] = strtok( NULL, SEPCHARS); /* extracting argument */
  }; line1argcount = i;
  if (strcmp( cmd1[0], "*" ) == 0 )
    flag1=2; /* wild card */
  if (flag1 == -1)
  {
    i=0;k=0; /* reset counters */
    while ( (k < line1argcount) ) /* check attributes */
    { /* check attributes */
      flag1=0; /* clearing flag */
      i=0;
      while (i < relations)
      { 
        j=0;
        while (j < rTABLE[i].relsize) /* loop thru attrubutes */
        { /* matching attributes */
          if ( strcmp( cmd1[k], rTABLE[i].paT[j].attrname ) == 0)
          { /* attribute found */
            flag1=1; /* set flag */
            cmd1count[k]=j;
            break; /* break out of loop to go to next cmd1 to find */
          }
          j++; /* increment counter for next attribute */
        }; /* end of attribute searching */
        i++; /* attribute was found, move on to next cmd1 to find */
        if (flag1==1)
          break; /* attribute was found, moving on to next input */
      };
      if (flag1 != 1) 
      { /* attribute was not found */
        printf("Attribute '%s' not found. \n", cmd1[k]); /* print err msg */
        break; /* break out of loop */
      }
      k++;
    };
  }
  
  if (flag1 >= 1)
  {
    printf( "   from: "); /* print prompt */
    i=0;
    while ( (ch = getchar())!= '\n' )
      line2[i++] = ch;
    line2[i] = '\0';
    i=0; /* reset counters */
    cmd2[0] = strtok(line2,SEPCHARS); 
    while ( cmd2[i]!= NULL ) 
    { /* extracting the arguments */
      i++;   /* increment 'i' */
      cmd2[i] = strtok( NULL, SEPCHARS); /* extracting argument */  
    };
  
    i=0; /* reset counters */
    while ( (i < relations) && (flag2 != 0) )
    {
      if (strcmp( cmd2[0], rTABLE[i].relname) == 0 )
      { /* relation found */
        flag2=1; /* set flag */
        icount = i;
        k=0;
        while ( (k < line1argcount) ) /* check attributes */
        { /* check attributes */
          flag1=0; /* clearing flag */
          j=0;
          while (j < rTABLE[i].relsize) /* loop thru attrubutes */
          { /* matching attributes */
            if ( strcmp( cmd1[k], rTABLE[i].paT[j].attrname ) == 0)
            { /* attribute found */
              flag1=1; /* set flag */
              break; /* break out of loop to go to next cmd1 to find */
            }
            j++; /* increment counter for next attribute */
          }; /* end of attribute searching */
          if (flag1 == 0) 
          { /* attribute was not found */
            printf("Attribute '%s' not found in relation '%s'. \n", cmd1[k], cmd2[0]); /* print err msg */
            break; /* break out of loop */
          }
          k++;
        };        
      }
      i++;
    }; 
    
    if (flag2 != 1) 
    { /* attribute was not found */
      printf("Relation '%s' not found. \n", cmd2[0]); /* print err msg */
    }
    
  };
  
  if ( (flag1 >= 1) && (flag2 == 1) )
  {
    printf( "   where: "); /* print prompt */
    i=0;
    while ( (ch = getchar())!= '\n' )
      line3[i++] = ch;
    line3[i] = '\0';
    i=0; /* reset counters */
    cmd3[0] = strtok(line3,SEPCHARS); 
    while ( cmd3[i]!= NULL ) 
    { /* extracting the arguments */
      i++;   /* increment 'i' */
      cmd3[i] = strtok( NULL, SEPCHARS); /* extracting argument */
    }; line3argcount = i;
    if (line3argcount != 3)
    {
      printf("invalid number of arugments in 'where:'.\n");
      flag3=0;
    };
    k=0; i=0;
    
    if ( (flag1 >= 1) && (flag2 == 1) && (flag3 == -1))
    { /* passed the first two tests */
      while ( (i < relations) )
      {
        flag3=-1;
        while (k < rTABLE[i].relsize) /* loop thru attrubutes */
        { /* matching attributes */
          if (strcmp( cmd3[0], rTABLE[i].paT[k].attrname ) == 0)
          { /* attribute found */
            kcount=k;
            if(  (strcmp( &rTABLE[i].paT[k].attrtype , cI ) == 0) && 
              (  (strcmp(cmd3[1], cLST) ==0)  || (strcmp(cmd3[1], cGRT) ==0)  ||
                 (strcmp(cmd3[1], cLET) ==0)  || (strcmp(cmd3[1], cGET) ==0)  ||
                 (strcmp(cmd3[1], cEQT) ==0)  || (strcmp(cmd3[1], cNEQ) ==0)  ) )
            {
              flag3=1; /* set flag */
              break;
            }
            else if(  (strcmp( &rTABLE[i].paT[k].attrtype , cS ) == 0) && 
                   (  (strcmp(cmd3[1], cEQT) ==0) || (strcmp(cmd3[1], cNEQ) ==0)  ) )
            {
              flag3=1; /* set flag */
              break;
            }
            else if (strcmp( cmd3[0], rTABLE[i].paT[k].attrname ) == 0 )
            {
              printf("Invalid argument condition in 'where:'.\n");
              flag3=0;
              break;
            }
          }
          k++; /* increment counter for next attribute */
        }; 
        i++;/* end of attribute searching */
        if (flag3!=-1)
          break;
      };
    }
    if (flag3==-1)
      printf("Argument not valid in 'where:'.\n");
  };

  if ( (flag1 == 1) && (flag2 == 1) && (flag3 == 1))
  { /* all entries are valid */
    /* do query */
    i=0;j=0;k=0;
    
    if (strcmp( cmd2[0], rTABLE[icount].relname ) == 0) 
    { /* relations name match */
      if ( (finp = fopen(rTABLE[icount].bfname, "r")) == NULL ) 
      {   /* open failed */
        fprintf(stderr, "Could not open file '%s' for reading. \n", rTABLE[icount].bfname); /* prints error */
        exit(1); /* exit due to failure in opening the file */
      };
      i=0;
      tuplesize=0;
      while (i < rTABLE[icount].relsize)
      {
        tuplesize += rTABLE[icount].paT[i].attrsize;
        i++;
      }; /* tuplesize holds the size of the row */
      k=0; j=0;
   while (feof(finp) == 0)
   {  
      while ((j < rTABLE[icount].paT[kcount].attrindex) && fread( &temp, sizeof(char), 1, finp))
        j++; /* read till tupleloc */
      i=0;
/*      while (i < rTABLE[icount].paT[kcount].attrsize)
      {  
        fread( &attrvar[i], sizeof(char), 1, finp );
        i++;
      }; */
      if ((memcpy( &attrvar, finp, rTABLE[icount].paT[kcount].attrsize )) !=0)
      {
        printf("error reading file");
        break;
      }
      i=0;j=0;k=0;
      if( strcmp( &rTABLE[icount].paT[kcount].attrtype, cI)==0)
      { /* attribute is of type int */
        if(strcmp(cmd3[1], cLST) ==0)
        {
          
        }
        
      }
      if( strcmp( &rTABLE[icount].paT[kcount].attrtype, cS)==0)
      { /* attribute is of type string */
        if(strcmp(cmd3[1], cEQT) ==0)
        {
        }
        
        
      }
  };/* end of loop */
  
    }
  };
  
}


