/*
Victor Ng
vn6216@albany.edu
csi402 Spring 2006

*/


#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "bconstants.h"
#include "bexterns.h"
//#include "bstruct_def.h"

/* pointers to commands for use with 'strcmp' */
//R format opcodes
static const char * cHLT = "hlt";   
static const char * cADD = "add";    
static const char * cSUB = "sub";    
static const char * cMUL = "mul";    
static const char * cDIV = "div";    
static const char * cMOD = "mod";    
static const char * cMOVE = "move";    
static const char * cAND = "and";    
static const char * cOR = "or";    
static const char * cXOR = "xor";    
static const char * cCOM = "com";    
static const char * cSLL = "sll";    
static const char * cSRL = "srl";    
static const char * cSRA = "sra";    
static const char * cJR = "jr";    
static const char * cRDR = "rdr";    
static const char * cPRR= "prr";    
static const char * cPRH = "prh";    
// I format op codes
static const char * cLI = "li";    
static const char * cADDI = "addi";    
static const char * cSUBI = "subi";    
static const char * cMULI = "muli";    
static const char * cDIVI = "divi";    
static const char * cMODI = "modi";    
static const char * cLWB = "lwb";    
static const char * cSWB = "swb";    
// J format op codes
static const char * cLWA = "lwa";    
static const char * cSWA = "swa";    
static const char * cJ = "j";    
static const char * cJAL = "jal";    
static const char * cJEQ = "jeq";    
static const char * cJNE = "jne";
static const char * cJLT = "jlt";    
static const char * cJLE = "jle";    
static const char * cJGT = "jgt";    
static const char * cJGE = "jge";         

// misc
static const char * newline = "\n";

void start()
{
  int i=0;
  // make optable for comparison
    // R format
    strcpy(optable[i], cHLT); i++;
    strcpy(optable[i], cADD); i++;
    strcpy(optable[i], cSUB); i++;
    strcpy(optable[i], cMUL); i++;
    strcpy(optable[i], cDIV); i++;
    strcpy(optable[i], cMOD); i++;
    strcpy(optable[i], cMOVE); i++;
    strcpy(optable[i], cAND); i++;
    strcpy(optable[i], cOR); i++;
    strcpy(optable[i], cXOR); i++;
    strcpy(optable[i], cCOM); i++;
    strcpy(optable[i], cSLL); i++;
    strcpy(optable[i], cSRL); i++;
    strcpy(optable[i], cSRA); i++;
    strcpy(optable[i], cJR); i++;
    strcpy(optable[i], cRDR); i++;
    strcpy(optable[i], cPRR); i++;
    strcpy(optable[i], cPRH); i++;
    // I format
    strcpy(optable[i], cLI); i++;
    strcpy(optable[i], cADDI); i++;
    strcpy(optable[i], cSUBI); i++;
    strcpy(optable[i], cMULI); i++;
    strcpy(optable[i], cDIVI); i++;
    strcpy(optable[i], cMODI); i++;
    strcpy(optable[i], cLWB); i++;
    strcpy(optable[i], cSWB); i++;
    // J format
    strcpy(optable[i], cLWA); i++;
    strcpy(optable[i], cSWA); i++;
    strcpy(optable[i], cJ); i++;
    strcpy(optable[i], cJAL); i++;
    strcpy(optable[i], cJEQ); i++;
    strcpy(optable[i], cJNE); i++;
    strcpy(optable[i], cJLT); i++;
    strcpy(optable[i], cJLE); i++;
    strcpy(optable[i], cJGT); i++;
    strcpy(optable[i], cJGE); i=0;
    
    while (i <= MEMSIZE)
    {
      objout[i] = 0;
      i++;
    }
  
}

void printtree (pNode * ptrNode, FILE * flst)
{
  pNode ptr = * ptrNode;
  
  if ( ptr->pleft )
    printtree (&ptr->pleft, flst); // travel left side by recursion 
  
  // no more right node, print this node's info
  fprintf(flst, "%d\t%s", ptr->pcval, ptr->nodestring);
   
  if ( ptr->pright )
    printtree (&ptr->pright, flst); // travel right side by recursion
  
  // no more right nodes, return and continue
}


void read(FILE * finp, FILE * flst)
{
  char *tempstring;
  int i=0, j=0;
  int linecount = 1, pc = 0;
  char *linenocmt;
  char *label;
  char *cmd, *vars;
  int opcode;
  pNode newNode, curptr, prevptr = NULL; // temporary pointers
  
  while ( !feof(finp) ) // read the line
  { // while there are still strings in the input file 
    if ( (tempstring = (char *) malloc(MAXLEN * sizeof(char)) ) == NULL ) // allocating memory of 'MAXLEN' characters
    { // error in allocating memory 
      fprintf(stderr, "Err: cannot allocate memory. \n"); // print error message 
      exit(1); // exit due to insufficient memory 
    };  
    if (fgets( tempstring, MAXLEN, finp )!= NULL)
    {
      fprintf(flst, " %d\t%s", linecount, tempstring);
      linecount++;
      j=0;
      while (tempstring[j] != '#')
        j++;
      tempstring[j+1] = '\0';
      linenocmt = strtok(tempstring,SEPNUMSIGN);// store line without comments
      if (linenocmt != NULL) 
      { 
        
fprintf(stderr, " %s \n", linenocmt);
        label = strtok(linenocmt,SEPCOLON);
fprintf(stderr, " ---  %s \n", label); 
        if (strcmp(label, linenocmt) !=0)
        { // label found
          newNode = malloc( sizeof( Node )); // allocate new node space
          newNode->pleft = NULL; // clear pointer
          newNode->pright = NULL; // clear pointer
          newNode->pcval = pc;
          strcpy(newNode->nodestring, tempstring); // saving string into node

          if (pTreeRoot != NULL)
          {  
            curptr = pTreeRoot; // reset pointer to start of tree
            while (curptr!=NULL)
            { // not reach a leaf
              prevptr = curptr; // saving ptr
              if ( strcmp(newNode->nodestring, prevptr->nodestring ) < 0) // before prev
                curptr = prevptr->pleft; // moving to left
              else if ( strcmp(newNode->nodestring, prevptr->nodestring ) > 0) // after prev
                curptr = prevptr->pright; // moving to right
              else
              { // error, label already exists
              
              } 
            }; // tmpptr is now pointing to NULL, tmpprevptr = pointer before NULL;
            if ( strcmp(newNode->nodestring, prevptr->nodestring) < 0) // before prev
              prevptr->pleft = newNode; // putting new node into place
            else if ( strcmp(newNode->nodestring, prevptr->nodestring) > 0) // after prev
              prevptr->pright = newNode; // putting new node into place 
          }
          else
          {
            pTreeRoot = newNode;
          }
        }
/*
        cmd = strtok(NULL,SEPSPACE); // get opcode
        vars = strtok(NULL,SEPSPACE); // get variable registers 
        
        
        //compare opcode
        opcode=0;
        while ((strcmp(optable[opcode],cmd) !=0) && (opcode < NUMOPCODE) )
          opcode++;
        
        if ( (opcode >=OPRFORM) && (opcode < OPIFORM) )
        {// R format
          
        }
        else if ( (opcode >=OPIFORM) && (opcode <OPJFORM) ) 
        {// I format
          
        }
        else if ( (opcode >=OPJFORM) && (opcode <=NUMOPCODE) ) 
        { // J format
          
        }
        else
        // error
        ;
*/        
        
        
       
        fprintf(stderr, " %s \n", linenocmt); 
        pc++;
      }
    };  
    free(tempstring);
  }; // end of while
  // now to print the tree 
  
  printtree (&pTreeRoot, flst);

}

