/*
Victor Ng
vn6216@albany.edu
csi402 Spring 2006

*/


#include <stdio.h>
#include <stdlib.h>

#include "aconstants.h"
#include "astruct_def.h"


pNode readfile ( FILE * finp )
{
  //char tempstring[SLEN]; // temp storage for string read
  char * tempstring;
  pNode pHeader; // pointer to root of tree
  pNode curptr, prevptr = NULL; // temporary pointers
  pNode newNode; //pointer to newly created node
  
  
  if ( (tempstring = (char *) malloc(SLEN * sizeof(char)) ) == NULL ) // allocating memory of 'MAXLEN' characters
    { // error in allocating memory 
      fprintf(stderr, "Err: cannot allocate memory. \n"); // print error message 
      exit(1); // exit due to insufficient memory 
    };  

//  fscanf( finp, "%s", tempstring);  // read string from file
  fgets( tempstring, SLEN, finp );
    newNode = malloc( sizeof( Node )); // allocate new node space
  pHeader = newNode; // saving root 
    newNode->pleft = NULL; // clear pointer
    newNode->pright = NULL; // clear pointer
  strcpy(newNode->nodestring, tempstring); // saving string into node
  
  if ( (tempstring = (char *) malloc(SLEN * sizeof(char)) ) == NULL ) // allocating memory of 'MAXLEN' characters
  { // error in allocating memory 
    fprintf(stderr, "Err: cannot allocate memory. \n"); // print error message 
    exit(1); // exit due to insufficient memory 
  }; 

  while (fgets( tempstring, SLEN, finp ) != NULL ) // read the string)
  { // while there are still strings in the input file 
//    fscanf( finp, "%s", tempstring);  // read the string
      newNode = malloc( sizeof( Node )); // allocate new node space
      newNode->pleft = NULL; // clear pointer
      newNode->pright = NULL; // clear pointer
      strcpy(newNode->nodestring, tempstring); // saving string into node
    
    curptr = pHeader; // reset pointer to start of tree
    while (curptr!=NULL)
    { // not reach a leaf
      prevptr = curptr; // saving ptr
      if ( strcmp(newNode->nodestring, prevptr->nodestring ) < 0) // before prev
        curptr = prevptr->pleft; // moving to left
      else if ( strcmp(newNode->nodestring, prevptr->nodestring ) > 0) // after prev
        curptr = prevptr->pright; // moving to right
      else
      { // error, should not happen
        fprintf(stderr, "Error in comparing string %s", tempstring);
        exit(1); // exit due to error
      }
    }; // tmpptr is now pointing to NULL, tmpprevptr = pointer before NULL;
    
    if ( strcmp(newNode->nodestring, prevptr->nodestring) < 0) // before prev
       prevptr->pleft = newNode; // putting new node into place
    else if ( strcmp(newNode->nodestring, prevptr->nodestring) > 0) // after prev
       prevptr->pright = newNode; // putting new node into place 
  if ( (tempstring = (char *) malloc(SLEN * sizeof(char)) ) == NULL ) // allocating memory of 'MAXLEN' characters
  { // error in allocating memory 
    fprintf(stderr, "Err: cannot allocate memory. \n"); // print error message 
    exit(1); // exit due to insufficient memory 
  }; 
  };  
  return pHeader; // return root
}



int countnodes (pNode * ptrNode)
{
  int count = 0; 
  int countL = 0;
  int countR = 0 ; 
  pNode ptr = * ptrNode;
  
  if ( ptr->nodestring )
    count = 1; 
  if ( ptr->pleft )
    countL = countnodes(&ptr->pleft); // travel left side by recursion  
  if ( ptr->pright )
    countR = countnodes(&ptr->pright); // travel right side by recursion
    
  return (count + countL + countR); // return amount of nodes in children nodes
}

int height (pNode * ptrNode)
{
  int countL = 0;
  int countR = 0 ; 
  pNode ptr = * ptrNode;
  
  if ( ptr->pleft )
  { // if left exists
    countL = height(&ptr->pleft) + 1; // travel left side by recursion  
  }
  if ( ptr->pright )
  { // if right exists
    countR = height(&ptr->pright) + 1; // travel right side by recursion
  }
  if (countL >= countR) // L is bigger/equal to R
    return countL; // return L
  else // if (countL < countR) // L is less than R
    return countR; // return R
}

int countleaves (pNode * ptrNode)
{
  int count=0; // counter
  pNode ptr = * ptrNode;
  
  if ( (ptr->pleft == NULL) && (ptr->pright == NULL)) // leaf node
    count++; // increment counter
  else 
  { // not a leaf node
    if ( ptr->pleft )
    count += countleaves(&ptr->pleft); // travel left side by recursion 
    if ( ptr->pright )
    count += countleaves(&ptr->pright); // travel right side by recursion
  }
    
  return (count); // return amount of leaves found
}




void output(FILE * foutp, pNode * ptrNode)
{
   int nodecount, leftcount=0, rightcount=0;
   int heightcount, leftheight=0, rightheight=0;
   int leaves;
   pNode ptr = * ptrNode;
   
   nodecount = countnodes(&ptr); // count number of nodes in tree
     fprintf( foutp, "No. of strings in the input file = %d \n", nodecount); // output nodecount
   heightcount = height(&ptr); // find height of tree
     fprintf( foutp, "Height of the search tree = %d \n", heightcount); // output heightcount
   leaves = countleaves(&ptr); // find number of leaves
     fprintf( foutp, "Number of leaves in the tree = %d \n", leaves); // output number of leaves found
   
   if (ptr->pleft) // if left exists
     leftheight = height(&ptr->pleft); // find height of left subtree  
   fprintf( foutp, "Height of the left subtree of root = %d \n", leftheight); // output leftheight
   
   if (ptr->pleft) // if left exists
   leftcount = countnodes(&ptr->pleft); // count number of nodes in tree
     fprintf( foutp, "No. of strings in the left subtree = %d \n", leftcount); // output leftcount
   
   if (ptr->pright) // if right exists
     rightheight = height(&ptr->pright); // find height of right subtree
   fprintf( foutp, "Height of the right subtree of root = %d \n", rightheight); // output rightheight
   
   if (ptr->pleft) // if left exists
     rightcount = countnodes(&ptr->pright); // count number of nodes in tree
   fprintf( foutp, "No. of strings in the right subtree = %d \n", rightcount); // output rightcount
   
}
