/*
Victor Ng
vn6216@albany.edu
csi402 Spring 2006

*/


#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "bconstants.h"
#include "bexterns.h"
//#include "bstruct_def.h"

/* pointers to commands for use with 'strcmp' */       
static const char * newline = "\n";
static const char * DOLLARSIGN = "\n";
static const char * cNULL = "\0";

void start()
{
  int i=0;
  // make optable for comparison
    // R format
    optable[i] = "hlt"; i++;  // 0
    optable[i] = "add"; i++;  // 1
    optable[i] = "sub"; i++;  // 2
    optable[i] = "mul"; i++;  // 3
    optable[i] = "div"; i++;  // 4
    optable[i] = "mod"; i++;  // 5
    optable[i] = "move"; i++; // 6
    optable[i] = "and"; i++;  // 7
    optable[i] = "or"; i++;   // 8
    optable[i] = "xor"; i++;  // 9
    optable[i] = "com"; i++;  // 10
    optable[i] = "sll"; i++;  // 11
    optable[i] = "srl"; i++;  // 12
    optable[i] = "sra"; i++;  // 13
    optable[i] = "jr"; i++;   // 14
    optable[i] = "rdr"; i++;  // 15
    optable[i] = "prr"; i++;  // 16
    optable[i] = "prh"; i++;  // 17
    // I format
    optable[i] = "li"; i++;   // 18
    optable[i] = "addi"; i++; // 19
    optable[i] = "subi"; i++; // 20
    optable[i] = "muli"; i++; // 21
    optable[i] = "divi"; i++; // 22
    optable[i] = "modi"; i++; // 23
    optable[i] = "lwb"; i++;  // 24
    optable[i] = "swb"; i++;  // 25
    // J format
    optable[i] = "lwa"; i++;  // 26
    optable[i] = "swa"; i++;  // 27
    optable[i] = "j"; i++;    // 28
    optable[i] = "jal"; i++;  // 29
    optable[i] = "jeq"; i++;  // 30
    optable[i] = "jne"; i++;  // 31
    optable[i] = "jlt"; i++;  // 32
    optable[i] = "jle"; i++;  // 33
    optable[i] = "jgt"; i++;  // 34
    optable[i] = "jge"; i++;  // 35
    optable[i] = "\0"; i=0;   // 36 = invalid opcode = space taker
    
    while (i <= MEMSIZE)
    {
      objout[i] = 0;
      i++;
    }
  
}

void printtree (pNode * ptrNode, FILE * flst)
{
  pNode ptr = * ptrNode;
  
  if ( ptr->pleft )
    printtree (&ptr->pleft, flst); // travel left side by recursion 
  
  // no more right node, print this node's info
  fprintf(flst, "%d\t%s \n", ptr->pcval, ptr->nodestring);
   
  if ( ptr->pright )
    printtree (&ptr->pright, flst); // travel right side by recursion
  
  // no more right nodes, return and continue
}


void read(FILE * finp, FILE * flst)
{
  char *line,*tempstring;  // line storage ( will be given malloc )
  int i=0, j=0; // counters
  int linecount = 1, pc = 0; // counters for line number and pc
  char *linenocmt; // storage for line after removing command
  char *label; // storage for label
  char *cmd, *vars; // storage for command and the registers
  int opcode; // int to cycle thru opcode table
  int tempintshift; // int use for binary shifting into place
  pNode newNode, curptr, prevptr = NULL; // temporary pointers
  int Rs1, Rs2, Rt; // registers in int form
  char *arg1, *arg2, *arg3; // registers in string form before atoi

  
  
  // first pass
  while ( !feof(finp) ) // read the line
  { // while there are still strings in the input file 
    if ( (line = (char *) malloc(MAXLEN * sizeof(char)) ) == NULL ) // allocating memory of 'MAXLEN' characters
    { // error in allocating memory 
      fprintf(stderr, "Err: cannot allocate memory. \n"); // print error message 
      exit(1); // exit due to insufficient memory 
    }; 
    if ( ( linenocmt = (char *) malloc(MAXLEN * sizeof(char)) ) == NULL ) // allocating memory of 'MAXLEN' characters
    { // error in allocating memory 
      fprintf(stderr, "Err: cannot allocate memory. \n"); // print error message 
      exit(1); // exit due to insufficient memory 
    }; 
    if (fgets( line, MAXLEN, finp )!= NULL)
    {
      fprintf(flst, " %d\t%s", linecount, line); // write line to the flst
      linecount++; // increment line counter
      j=0; // reset counter
      // remove comments from the line
      while ((line[j] != '\n') && (j < MAXLEN-1) ) 
      { 
        if (line[j] == '#')
        { // if char is a '#'
          line[j+1] = '\0'; // next char is NULL char
          break; // break out of loop
        }  
        j++;// increment counter
      };
      tempstring = strtok(line,SEPNUMSIGN); // break line without comments
      if (tempstring != NULL) 
      { // linenocmt is not empty,
        strcpy(linenocmt, tempstring); // saving the line without comments
        label = strtok(tempstring,SEPCOLON); // separating label
        if ( (label != NULL) && (strcmp(label, linenocmt) != 0) ) // compare line with and without comments, if they match, a label exists 
        { // label found
          newNode = malloc( sizeof( Node )); // allocate new node space
          newNode->pleft = NULL; // clear pointer
          newNode->pright = NULL; // clear pointer
          newNode->pcval = pc; // saving pc into node
          strcpy(newNode->nodestring, tempstring); // saving string into node

          if (pTreeRoot != NULL)
          {  
            curptr = pTreeRoot; // reset pointer to start of tree
            while (curptr!=NULL)
            { // not reach a leaf
              prevptr = curptr; // saving ptr
              if ( strcmp(newNode->nodestring, prevptr->nodestring ) < 0) // before prev
                curptr = prevptr->pleft; // moving to left
              else if ( strcmp(newNode->nodestring, prevptr->nodestring ) > 0) // after prev
                curptr = prevptr->pright; // moving to right
              else
              { // error, label already exists
                
              } 
            }; // tmpptr is now pointing to NULL, tmpprevptr = pointer before NULL;
            if ( strcmp(newNode->nodestring, prevptr->nodestring) < 0) // before prev
              prevptr->pleft = newNode; // putting new node into place
            else if ( strcmp(newNode->nodestring, prevptr->nodestring) > 0) // after prev
              prevptr->pright = newNode; // putting new node into place 
          }
          else
          { // pTreeRoot is empty
            pTreeRoot = newNode;
          }
        }      
        pc++;
      }
    };  
    free(tempstring);
    free(linenocmt);
  }; // end of while
  // end of first pass
  fseek(finp,0L,SEEK_SET); // reset fileinput pointer
  // now to print the symbol tabel tree to flst
  if (pTreeRoot != NULL)
  { // there are labels declared in the symbol table
    fprintf(flst, " Symbol Table: \n ------------- \n");
    printtree (&pTreeRoot, flst);
  }// finish printing symbol tabel
  
  // second pass
  while ( !feof(finp) ) // read the line
  { // while there are still strings in the input file 
    if ( (line = (char *) malloc(MAXLEN * sizeof(char)) ) == NULL ) // allocating memory of 'MAXLEN' characters
    { // error in allocating memory 
      fprintf(stderr, "Err: cannot allocate memory. \n"); // print error message 
      exit(1); // exit due to insufficient memory 
    }; 
    if ( ( linenocmt = (char *) malloc(MAXLEN * sizeof(char)) ) == NULL ) // allocating memory of 'MAXLEN' characters
    { // error in allocating memory 
      fprintf(stderr, "Err: cannot allocate memory. \n"); // print error message 
      exit(1); // exit due to insufficient memory 
    }; 
    if (fgets( line, MAXLEN, finp )!= NULL)
    {
      fprintf(flst, " %d\t%s", linecount, line); // write line to the flst
      linecount++; // increment line counter
      j=0; // reset counter
      // remove comments from the line
      while ((line[j] != '\n') && (j < MAXLEN-1) ) 
      { 
        if (line[j] == '#')
        { // if char is a '#'
          line[j+1] = '\0'; // next char is NULL char
          break; // break out of loop
        }  
        j++;// increment counter
      };
      tempstring = strtok(line,SEPNUMSIGN); // break line without comments
      if (tempstring != NULL) 
      { // linenocmt is not empty,
        strcpy(linenocmt, tempstring); // saving the line without comments
        label = strtok(tempstring,SEPCOLON); // separating label
        
        cmd = strtok(NULL,SEPSPACE); // get opcode
        vars = strtok(NULL,SEPSPACE); // get variable registers 
        
        if ((cmd != NULL) && (vars != NULL))
        {
          //compare opcode
          opcode=0;
          while ((strcmp(optable[opcode],cmd) !=0) && (opcode <= NUMOPCODE+1) )
            opcode++; // cycle thru optable for matching opcode
          // opcode found or = NUMOPCODE if opcode is invalid
          tempintshift = opcode << 26; // binary shifting into place
          objout[pc] |= tempintshift; // putting opcode into objout array
          
          if (opcode == 0)
          {
            
          } 
          
          // R format ||| Rs1 Rs2 Rt sa 
          else if ( ( (opcode >=1) && (opcode <= 5 ) ) ||
                    ( (opcode >=7) && (opcode <= 9 ) )  )
          {
            arg1 = strtok(NULL,SEPCOMMA); // reading arg1
            arg2= strtok(NULL,SEPCOMMA); // reading arg2
            arg3 = strtok(NULL,SEPCOMMA); // reading arg3
            if ( (arg1!=NULL) && (&arg1[0] != "$") )
            { // valid argument
              i=0; // reset counter 
              while (&arg1[0] != "$")
                arg1[i]=arg1[i+1]; // remove "$"
              Rt = atoi(arg3); // convert to int
              if ((Rt > 0) && (Rt <=31)) 
              { // valid register
                tempintshift = Rt << 11; // binary shifting into place
                objout[pc] |= tempintshift; // putting opcode into objout array
              }else if (Rt == 0){;} // do nothing if $0
              else // register is not 0-31
              ;
            }
            else // arg is not $X
            ;
            if ( (arg2!=NULL) && (&arg2[0] != "$") )
            { // valid argument
              i=0; // reset counter 
              while (&arg2[i+1] != "\0")
                arg2[i]=arg2[i+1]; // remove "$"
              Rs1 = atoi(arg2); // convert to int
              if ((Rs1 > 0) && (Rs1 <=31))
              { // valid register
                tempintshift = Rs1 << 21; // binary shifting into place
                objout[pc] |= tempintshift; // putting opcode into objout array
              }else if (Rs1 == 0){;} // do nothing if $0
              else // register is not 0-31
              ;
            }
            else // arg is not $X
            ;
            if ( (arg3!=NULL) && (&arg3[0] != "$") )
            { // valid argument
              i=0; // reset counter 
              while (&arg3[i+1] != "\0")
                arg3[i]=arg3[i+1]; // remove "$"
              Rs2 = atoi(arg3); // convert to int
              if ((Rs2 > 0) && (Rs2 <=31))
              { // valid register
                tempintshift = Rs2 << 16; // binary shifting into place
                objout[pc] |= tempintshift; // putting opcode into objout array
              }else if (Rs2 == 0){;} // do nothing if $0
              else // register is not 0-31
              ;
            }
            else // arg is not $X
            ;
          }
          else if ( (opcode >=11) && (opcode <= 13) )   
          {
            arg1 = strtok(NULL,SEPCOMMA); // reading arg1
            arg2= strtok(NULL,SEPCOMMA); // reading arg2
            arg3 = strtok(NULL,SEPCOMMA); // reading arg3
            if ( (arg1!=NULL) && (&arg1[0] == "$") )
            { // valid argument
              i=0; // reset counter 
              while (&arg1[i+1] != "\0")
                arg1[i]=arg1[i+1]; // remove "$"
              Rt = atoi(arg1); // convert to int
              if ((Rt > 0) && (Rt <=31))
              { // valid register
                tempintshift = Rt << 11; // binary shifting into place
                objout[pc] |= tempintshift; // putting opcode into objout array
              }else if (Rt == 0){;} // do nothing if $0
              else // register is not 0-31
              ;
            }
            else // arg is not $X
            ;
            if ( (arg2!=NULL) && (&arg2[0] != "$") )
            { // valid argument
              i=0; // reset counter 
              while (&arg2[i+1] != "\0")
                arg2[i]=arg2[i+1]; // remove "$"
              Rs1 = atoi(arg2); // convert to int
              if ((Rs1 > 0) && (Rs1 <=31))
              { // valid register
                tempintshift = Rs1 << 21; // binary shifting into place
                objout[pc] |= tempintshift; // putting opcode into objout array
              }else if (Rs1 == 0){;} // do nothing if $0
              else // register is not 0-31
              ;
            }
            else // arg is not $X
            ;
            if ( (arg3!=NULL) )
            { // valid argument ( not really a register, but using Rs2 anyways )
              Rs2 = atoi(arg3); // convert to int
              if ((Rs2 >= 0) && (Rs2 <= 63))
              { 
                tempintshift = Rs2 << 6; // binary shifting into place
                objout[pc] |= tempintshift; // putting opcode into objout array
              }
              else // too big
              ;
            }
            else // arg is invalid
            ;
            
          }
          else if ( ( (opcode >=14) && (opcode <= 17 ) ) ||
                    (opcode == 6) && (opcode == 10)      )
          {
            arg1 = strtok(NULL,SEPSPCNL);
            if ( (arg1!=NULL) && (&arg1[0] == "$") )
            { // valid argument
              i=0; // reset counter 
              while (&arg1[i+1] != "\0")
                arg1[i]=arg1[i+1]; // remove "$"
              Rt = atoi(arg1); // convert to int
              if ((Rt > 0) && (Rt <=31))
              { // valid register
                tempintshift = Rt << 11; // binary shifting into place
                objout[pc] |= tempintshift; // putting opcode into objout array
              }else if (Rt == 0){;} // do nothing if $0
              else // register is not 0-31
              ;
            }
          }
          
          // I format ||| Rs Rt immediate opd
          else if ( (opcode >= 19) && (opcode <=23) ) 
          {
             
          }
          
          // J format ||| Rs Rt Address
          else if ( (opcode >= OPJFORM) && (opcode < NUMOPCODE) ) 
          { 
              
          }
          else //
          // error
          ;
        }
        else if (
        { // ERR cmd and/or vars not specified
          
        }
            
        pc++;
      }
    };  
    free(tempstring);
    free(linenocmt);
  }; // end of while



}

/*

*/
