/*
Victor Ng
vn6216@albany.edu
csi402 Spring 2006

*/


#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "bconstants.h"
  #include "bstruct_def.h"
#include "bexterns.h"

/* pointers to commands for use with 'strcmp' */       
static const char * dottext = ".text";
static const char * dotword = ".word";
static const char * dotresw = ".resw";
static const char * dotdata = ".data";
static const char * ERR5 = "Invalid label. ";
static const char * ERR4 = "Undefined symbol used. ";
static const char * ERR3 = "Illegal opcode. ";
static const char * ERR2 = "Wrong number of operands. ";
static const char * ERR1 = "Invalid operand. ";
static const char * ERRX = "Error. ";
static const char * id_chars = "abcdefghijklmnopqurstuvxyzABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789_";


void start()
{
  int i=0;
  // make optable for comparison
    // R format
    optable[i] = "hlt"; i++;  // 0
    optable[i] = "add"; i++;  // 1
    optable[i] = "sub"; i++;  // 2
    optable[i] = "mul"; i++;  // 3
    optable[i] = "div"; i++;  // 4
    optable[i] = "mod"; i++;  // 5
    optable[i] = "move"; i++; // 6
    optable[i] = "and"; i++;  // 7
    optable[i] = "or"; i++;   // 8
    optable[i] = "xor"; i++;  // 9
    optable[i] = "com"; i++;  // 10
    optable[i] = "sll"; i++;  // 11
    optable[i] = "srl"; i++;  // 12
    optable[i] = "sra"; i++;  // 13
    optable[i] = "jr"; i++;   // 14
    optable[i] = "rdr"; i++;  // 15
    optable[i] = "prr"; i++;  // 16
    optable[i] = "prh"; i++;  // 17
    // I format
    optable[i] = "li"; i++;   // 18
    optable[i] = "addi"; i++; // 19
    optable[i] = "subi"; i++; // 20
    optable[i] = "muli"; i++; // 21
    optable[i] = "divi"; i++; // 22
    optable[i] = "modi"; i++; // 23
    optable[i] = "lwb"; i++;  // 24
    optable[i] = "swb"; i++;  // 25
    // J format
    optable[i] = "lwa"; i++;  // 26
    optable[i] = "swa"; i++;  // 27
    optable[i] = "j"; i++;    // 28
    optable[i] = "jal"; i++;  // 29
    optable[i] = "jeq"; i++;  // 30
    optable[i] = "jne"; i++;  // 31
    optable[i] = "jlt"; i++;  // 32
    optable[i] = "jle"; i++;  // 33
    optable[i] = "jgt"; i++;  // 34
    optable[i] = "jge"; i++;  // 35
    optable[i] = "\0"; i=0;   // 36 = invalid opcode = space taker
    
    while (i <= MEMSIZE)
    {
      objout[i] = 0;
      i++;
    }
  
}

void printtree (pNode * ptrNode, FILE * flst)
{
  pNode ptr = * ptrNode;
  
  if ( ptr->pleft )
    printtree (&ptr->pleft, flst); // travel left side by recursion 
  
  // no more right node, print this node's info
  fprintf(flst, " %s  %d \n", ptr->nodestring, ptr->pcval);
   
  if ( ptr->pright )
    printtree (&ptr->pright, flst); // travel right side by recursion
  
  // no more right nodes, return and continue
}

int searchtree (pNode * ptrNode, char * argument)
{
  pNode ptr = * ptrNode;
  int destpc =-1;
  
  if (strcmp(ptr->nodestring, argument) == 0)
  {
    destpc = ptr->pcval;
    return destpc;
  }
  if ( ptr->pleft )
  {
    destpc = searchtree (&ptr->pleft,argument); // travel left side by recursion
    if (destpc != -1)
      return destpc;
  }
  if ( ptr->pright )
  {
    destpc = searchtree (&ptr->pright, argument); // travel right side by recursion
    if (destpc != -1)
      return destpc;
  }
  return -1;
}

void read(FILE * finp, FILE * flst)
{
  char *line,*tempstring;  // line storage ( will be given malloc )
  int i=0, j=0; // counters
  int linecount = 1, pc = 0; // counters for line number and pc
  char *linenocmt; // storage for line after removing command
  char *label; // storage for label
  char *cmd, *vars; // storage for command and the registers
  int opcode; // int to cycle thru opcode table
  int tempintshift; // int use for binary shifting into place
  pNode newNode, curptr, prevptr = NULL; // temporary pointers
  pErrorLine newError = NULL;
  int Rs1, Rs2, Rt; // registers in int form
  char *arg1, *arg2, *arg3; // registers in string form before atoi
  char *argtemp, *argreg1, *argreg2, *argreg3;
  int flagError; //errorflag: -1,0,1,2,3;
  
  
// first pass
  while ( !feof(finp) ) // read the line
  { // while there are still strings in the input file 
    if ( (line = (char *) malloc(MAXLEN * sizeof(char)) ) == NULL ) // allocating memory of 'MAXLEN' characters
    { // error in allocating memory 
      fprintf(stderr, "Err: cannot allocate memory. \n"); // print error message 
      exit(1); // exit due to insufficient memory 
    }; 
    if ( ( linenocmt = (char *) malloc(MAXLEN * sizeof(char)) ) == NULL ) // allocating memory of 'MAXLEN' characters
    { // error in allocating memory 
      fprintf(stderr, "Err: cannot allocate memory. \n"); // print error message 
      exit(1); // exit due to insufficient memory 
    }; 
    if (fgets( line, MAXLEN, finp )!= NULL)
    {
      fprintf(flst, " %d \t%s", linecount, line); // write line to the flst
      j=0; // reset counter
      // remove comments from the line
      while ((line[j] != '\n') && (j < MAXLEN-1) ) 
      { 
        if (line[j] == '#')
        { // if char is a '#'
          line[j+1] = '\0'; // next char is NULL char
          break; // break out of loop
        }  
        j++;// increment counter
      };
      tempstring = strtok(line,SEPNUMSIGN); // break line without comments
      if (tempstring != NULL) 
      { // linenocmt is not empty,
        strcpy(linenocmt, tempstring); // saving the line without comments
        label = strtok(tempstring,SEPCOLON); // separating label
        if ( (label != NULL) && (strcmp(label, linenocmt) != 0)  /*&& (strspn(label,id_chars) != (strlen(label)) )*/ ) 
        // compare line with and without comments, if they do not match, a label exists 
        { // label found
          cmd = strtok(NULL,SEPSPCNL); // get opcode from strtok pointer
          vars = strtok(NULL,SEPSPCNL); // get variable registers
          
          newNode = malloc( sizeof( Node )); // allocate new node space
          newNode->pleft = NULL; // clear pointer
          newNode->pright = NULL; // clear pointer
          newNode->pcval = pc; // saving pc into node
          strcpy(newNode->nodestring, tempstring); // saving string into node

          if (pTreeRoot != NULL)
          {  
            curptr = pTreeRoot; // reset pointer to start of tree
            while (curptr!=NULL)
            { // not reach a leaf
              prevptr = curptr; // saving ptr
              if ( strcmp(newNode->nodestring, prevptr->nodestring ) < 0) // before prev
                curptr = prevptr->pleft; // moving to left
              else if ( strcmp(newNode->nodestring, prevptr->nodestring ) > 0) // after prev
                curptr = prevptr->pright; // moving to right
              else
              { // error, label already exists
                break; // error to be printed later
              } 
            }; // tmpptr is now pointing to NULL, tmpprevptr = pointer before NULL;
            if ( strcmp(newNode->nodestring, prevptr->nodestring) < 0) // before prev
              prevptr->pleft = newNode; // putting new node into place
            else if ( strcmp(newNode->nodestring, prevptr->nodestring) > 0) // after prev
              prevptr->pright = newNode; // putting new node into place 
            else
            { // print error
              newError = malloc( sizeof( ErrorLine ));
              strcpy(newError->line, label);
              newError->lineval = linecount;
              newError->next = NULL;
              if (pmulticur != NULL)
              {
                pmulticur->next = newError;
                pmultiprev = pmulticur;
                pmulticur = pmulticur->next;
              }
              else
                pmulticur = newError;
              if (pMultiError == NULL)
                pMultiError = pmulticur;
              ;
            }
          }
          else
          { // pTreeRoot is empty
            pTreeRoot = newNode;
          }
          
        }
        else 
        { // didn't read a label
          cmd = strtok(label,SEPSPCNL); // get argument from string
          vars = strtok(NULL,SEPSPCNL); // get variable registers
        };
        
        if (cmd == NULL) 
        { 
          // ERR cmd and/or vars not specified
          //do nothing for now, this error checking comes later
        }
        else if ( (strcmp(cmd, dottext)==0) || (strcmp(cmd, dotdata)==0) )
        {
          pc--;
        }
        else if (strcmp(cmd, dotresw)==0) 
        {
          arg1 = strtok(vars,SEPSPCNL); // reading arg1
          if ( (arg1!=NULL) )
          { // valid argument ( not really a register, but using Rs2 anyways )
            Rs1 = atoi(arg1); // convert to int
            if ((Rs2 < 0))
              flagError = 1; // invalid operand   
            while (Rs1 > 0)
            {
              pc++;
              Rs1--;
            }
            pc--;
          }
        }
        else if (strcmp(cmd, dotword)==0) 
        {
          arg1 = strtok(vars,SEPCOLON); // reading arg1
          arg2 = strtok(NULL,SEPSPCNL); // reading arg2
          if ( (arg1!=NULL) )
          { // valid argument ( not really a register, but using Rs2 anyways )
            Rt = atoi(arg1); // convert to int
          }
          if ( (arg2!=NULL) )
          { // valid argument ( not really a register, but using Rs2 anyways )
            Rs1 = atoi(arg2); // convert to int
            if ((Rs2 <= 0))
              flagError = 1; // invalid operand 
            while (Rs1 > 0)
            {
              pc++;
              Rs1--;
            }
            pc--;
          }
        };
        pc++;
      }
      
    linecount++; // increment line counter
    };  
    free(tempstring);
    free(linenocmt);
  }; // end of while
  // end of first pass
  fseek(finp,0L,SEEK_SET); // reset fileinput pointer
  
// second pass
  linecount = 1;
  pc=0;
  flagError=0;
  while ( !feof(finp) ) // read the line
  { // while there are still strings in the input file 
  flagError = 0;
    if ( (line = (char *) malloc(MAXLEN * sizeof(char)) ) == NULL ) // allocating memory of 'MAXLEN' characters
    { // error in allocating memory 
      fprintf(stderr, "Err: cannot allocate memory. \n"); // print error message 
      exit(1); // exit due to insufficient memory 
    }; 
    if ( ( linenocmt = (char *) malloc(MAXLEN * sizeof(char)) ) == NULL ) // allocating memory of 'MAXLEN' characters
    { // error in allocating memory 
      fprintf(stderr, "Err: cannot allocate memory. \n"); // print error message 
      exit(1); // exit due to insufficient memory 
    }; 
    if (fgets( line, MAXLEN, finp )!= NULL)
    {
      j=0; // reset counter
      // remove comments from the line
      while ((line[j] != '\n') && (j < MAXLEN-1) ) 
      { 
        if (line[j] == '#')
        { // if char is a '#'
          line[j+1] = '\0'; // next char is NULL char
          break; // break out of loop
        }  
        j++;// increment counter
      };
      tempstring = strtok(line,SEPNUMSIGN); // break line without comments
      if (tempstring != NULL) 
      { // linenocmt is not empty,
        flagError = 0;
        strcpy(linenocmt, tempstring); // saving the line without comments
        label = strtok(tempstring,SEPCOLON); // separating label        
        if ( (label != NULL) && (strcmp(label, linenocmt) != 0) ) // compare line with and without comments, if they don't match, a label exists 
        { // label read
          cmd = strtok(NULL,SEPSPCNL); // get opcode from strtok pointer
          vars = strtok(NULL,SEPSPCNL); // get variable registers
          
          if( (strspn(label,id_chars)) != (strlen(label)) )
            flagError = 5;
        }
        else 
        { // didn't read a label
          cmd = strtok(label,SEPSPCNL); // get argument from string
          vars = strtok(NULL,SEPSPCNL); // get variable registers
        }
        
        if (cmd == NULL) 
        { 
          // ERR cmd and/or vars not specified
          flagError = 2;
        }
        else if (flagError == 5)
        {
          ;
        }
        else if ( (strcmp(cmd, dottext)==0) || (strcmp(cmd, dotdata)==0) )
        {
          ;
        }
        else if ( strcmp(cmd, dotresw)==0 ) 
        {
          arg1 = strtok(vars,SEPSPCNL); // reading arg1
          if ( (arg1!=NULL) )
          { // valid argument ( not really a register, but using Rs2 anyways )
            Rs1 = atoi(arg1); // convert to int
            if ((Rs2 < 0))
              flagError = 1; // invalid operand 
            else
            {
              while (Rs1 > 0)
              {
                pc++;
                Rs1--;
              }
            };
          }
          else
            flagError = 2;
        }
        else if ( strcmp(cmd, dotword)==0 ) 
        {
          arg1 = strtok(vars,SEPCOLON); // reading arg1
          arg2 = strtok(NULL,SEPSPCNL); // reading arg2
          if ( (arg1!=NULL) )
          { // valid argument ( not really a register, but using Rs2 anyways )
            Rt = atoi(arg1); // convert to int
          }
          else  // argument is NULL
            flagError = 2; // invalid number of arguments
		  ; 
          if ( (arg2!=NULL) )
          { // valid argument ( not really a register, but using Rs2 anyways )
            Rs1 = atoi(arg2); // convert to int
            if ((Rs2 < 0))
              flagError = 1; // invalid operand 
            else
            {
              while (Rs1 > 0)
              {
                objout[pc] |= Rt;
                pc++;
                Rs1--;
              }
            };
          }
          else  // argument is NULL
            flagError = 2; // invalid number of arguments
		  ; 
        }
        else if ((cmd != NULL))
        {
          //compare opcode
          opcode=0;
          while (opcode <= NUMOPCODE )
          {
            if (strcmp(optable[opcode],cmd) ==0)
              break;
            else
              opcode++; // cycle thru optable for matching opcode
          };
// opcode found or = NUMOPCODE if opcode is invalid
          
          tempintshift = opcode << 26; // binary shifting into place
          objout[pc] |= tempintshift; // putting opcode into objout array
          tempintshift=0;
          if ((opcode < 0) || (opcode > NUMOPCODE) )
            flagError = 3;
          else if (opcode == 0)
          {
            ;
          }
          else if ( (vars == NULL) )
          {
            flagError = 2;
          }
// R format ||| Rs1 Rs2 Rt sa 
//1-5 7-9
          else if ( ( (opcode >=1) && (opcode <= 5 ) ) ||
                    ( (opcode >=7) && (opcode <= 9 ) )  )
          {
            argreg1 = strtok(vars,SEPCOMMA); // reading arg1
            argreg2 = strtok(NULL,SEPCOMMA); // reading arg3
            argreg3 = strtok(NULL,SEPSPCNL); // reading arg3
            arg1 = strtok(argreg1,SEPDOLLAR); // remove "$"
            if ( (arg1!=NULL) && (strcmp(argreg1, arg1) !=0)  )
            { // valid argument
              Rt = atoi(arg3); // convert to int
              if ((Rt > 0) && (Rt <=31)) 
              { // valid register
                tempintshift = Rt << 11; // binary shifting into place
                objout[pc] |= tempintshift; // putting opcode into objout array
                tempintshift=0;
              }else if (Rt == 0){;} // do nothing if $0
              else // register is not 0-31
                flagError = 1; // invalid operand 
            }
	        else if ( (arg1!=NULL) && (strcmp(argreg1, arg1) == 0) ) 
              flagError = 1; // invalid operand
            else  // argument is NULL
              flagError = 2; // invalid number of arguments
		    ;
            arg2 = strtok(argreg2,SEPDOLLAR); // remove "$"	
            if ( (arg2!=NULL) && (strcmp(argreg2, arg2) != 0) )
            { // valid argument
              Rs1 = atoi(arg2); // convert to int
              if ((Rs1 > 0) && (Rs1 <=31))
              { // valid register
                tempintshift = Rs1 << 21; // binary shifting into place
                objout[pc] |= tempintshift; // putting opcode into objout array
                tempintshift=0;
              }else if (Rs1 == 0){;} // do nothing if $0
              else // register is not 0-31
                flagError = 1; // invalid operand 
            }
	        else if ( (arg2!=NULL) && (strcmp(argreg2, arg2) == 0) ) 
              flagError = 1; // invalid operand
            else  // argument is NULL
              flagError = 2; // invalid number of arguments
		    ;
		    arg3 = strtok(argreg3,SEPDOLLAR); // remove "$"	
            if ( (arg3!=NULL) && (strcmp(argreg3, arg3) != 0) )
            { // valid argument
              Rs2 = atoi(arg3); // convert to int
              if ((Rs2 > 0) && (Rs2 <=31))
              { // valid register
                tempintshift = Rs2 << 16; // binary shifting into place
                objout[pc] |= tempintshift; // putting opcode into objout array
                tempintshift=0;
              }else if (Rs2 == 0){;} // do nothing if $0
              else // register is not 0-31
                flagError = 1; // invalid operand 
            }
	        else if ( (arg3!=NULL) && (strcmp(argreg3, arg3) == 0) ) 
              flagError = 1; // invalid operand
            else  // argument is NULL
              flagError = 2; // invalid number of arguments
            ;
		  }
//11-13
          else if ( (opcode >=11) && (opcode <= 13) )   
          {
            argreg1 = strtok(vars,SEPCOMMA); // reading arg1
            argreg2 = strtok(NULL,SEPCOMMA); // reading arg3
            arg3 = strtok(NULL,SEPSPCNL); // reading arg3
            arg1 = strtok(argreg1,SEPDOLLAR); // remove "$"
            if ( (arg1!=NULL) && (strcmp(argreg1, arg1) != 0) )
            { // valid argument
              Rt = atoi(arg1); // convert to int
              if ((Rt > 0) && (Rt <=31))
              { // valid register
                tempintshift = Rt << 11; // binary shifting into place
                objout[pc] |= tempintshift; // putting opcode into objout array
                tempintshift=0;
              }else if (Rt == 0){;} // do nothing if $0
              else flagError = 1; // invalid operand 
            }
	        else if ( (arg1!=NULL) && (strcmp(argreg1, arg1) == 0) ) 
              flagError = 1; // invalid operand
            else  // argument is NULL
              flagError = 2; // invalid number of arguments
		    ;
		    arg2 = strtok(argreg2,SEPDOLLAR); // remove "$"
            if ( (arg2!=NULL) && (strcmp(argreg2, arg2) != 0) )
            { // valid argument
              Rs1 = atoi(arg2); // convert to int
              if ((Rs1 > 0) && (Rs1 <=31))
              { // valid register
                tempintshift = Rs1 << 21; // binary shifting into place
                objout[pc] |= tempintshift; // putting opcode into objout array
                tempintshift=0;
              }else if (Rs1 == 0){;} // do nothing if $0
              else // register is not 0-31 
                flagError = 1; // invalid operand 
            }
	        else if ( (arg2!=NULL) && (strcmp(argreg2, arg2) == 0) ) 
              flagError = 1; // invalid operand
            else  // argument is NULL
              flagError = 2; // invalid number of arguments
		    ;
            if ( (arg3!=NULL) )
            { // valid argument ( not really a register, but using Rs2 anyways )
              Rs2 = atoi(arg3); // convert to int
              if ((Rs2 >= 0) && (Rs2 <= 63))
              { 
                tempintshift = Rs2 << 6; // binary shifting into place
                objout[pc] |= tempintshift; // putting opcode into objout array
                tempintshift=0;
              }
              else // too big
                flagError = 1; // invalid operand 
            }
            else  // argument is NULL
              flagError = 2; // invalid number of arguments
		    ; 
          }
// 14-17, 6, 10
          else if ( ( (opcode >=14) && (opcode <= 17 ) ) ||
                    (opcode == 6) || (opcode == 10)      )
          {
            argreg1 = strtok(vars,SEPSPCNL); // reading arg1
            arg1 = strtok(argreg1,SEPDOLLAR); // remove "$"
            if ( (arg1!=NULL) && (strcmp(argreg1, arg1) != 0) )
            { // valid argument
              Rt = atoi(arg1); // convert to int
              if ((Rt > 0) && (Rt <=31))
              { // valid register
                tempintshift = Rt << 11; // binary shifting into place
                objout[pc] |= tempintshift; // putting opcode into objout array
                tempintshift=0;
              }else if (Rt == 0){;} // do nothing if $0
              else // register is not 0-31
                flagError = 1; // invalid operand 
            }
          }
          
// I format ||| Rs Rt immediate opd
// 18
          else if (opcode == 18)
          {
            argreg1 = strtok(vars,SEPCOMMA); // reading arg1
            arg2 = strtok(NULL,SEPSPCNL); // reading arg3
            arg1 = strtok(argreg1,SEPDOLLAR); // remove "$"
            if ( (arg1!=NULL) && (strcmp(argreg1, arg1) != 0) )
            { // valid argument
              i=0; // reset counter 
              arg1[0] = arg1[1]; // remove "$"
              Rt = atoi(arg1); // convert to int
              if ((Rt > 0) && (Rt <=31))
              { // valid register
                tempintshift = Rt << 16; // binary shifting into place
                objout[pc] |= tempintshift; // putting opcode into objout array
                tempintshift=0;
              }else if (Rt == 0){;} // do nothing if $0
              else // register is not 0-31
                flagError = 1; // invalid operand 
            }
            if ( (arg2!=NULL) )
            { // valid argument ( not really a register, but using Rs2 anyways )
              Rs2 = atoi(arg2); // convert to int
              if ((Rs2 >= 0) && (Rs2 <= MEMSIZE))
              { 
                tempintshift = Rs2 << 0; // binary shifting into place
                objout[pc] |= tempintshift; // putting opcode into objout array
                tempintshift=0;
              }
              else // too big
                flagError = 1; // invalid operand 
            }
            else  // argument is NULL
              flagError = 2; // invalid number of arguments
		    ; 
          }
//19-23
          else if ( (opcode >= 19) && (opcode <= 23) ) 
          {
            argreg1 = strtok(vars,SEPCOMMA); // reading arg1
            argreg2 = strtok(NULL,SEPCOMMA); // reading arg2
            arg3 = strtok(NULL,SEPSPCNL); // reading arg3
            arg1 = strtok(argreg1,SEPDOLLAR); // remove "$"
            if ( (arg1!=NULL) && (strcmp(argreg1, arg1) != 0) )
            { // valid argument
              Rt = atoi(arg1); // convert to int
              if ((Rt > 0) && (Rt <=31))
              { // valid register
                tempintshift = Rt << 16; // binary shifting into place
                objout[pc] |= tempintshift; // putting opcode into objout array
                tempintshift=0;
              }else if (Rt == 0){;} // do nothing if $0
              else flagError = 1; // invalid operand 
            }
	        else if ( (arg1!=NULL) && (strcmp(argreg1, arg1) == 0) ) 
              flagError = 1; // invalid operand
            else  // argument is NULL
              flagError = 2; // invalid number of arguments
		    ;
            arg2 = strtok(argreg1,SEPDOLLAR); // remove "$"
            if ( (arg2!=NULL) )
            { // valid argument
              Rs1 = atoi(arg2); // convert to int
              if ((Rs1 > 0) && (Rs1 <=31))
              { // valid register
                tempintshift = Rs1 << 0; // binary shifting into place
                objout[pc] |= tempintshift; // putting opcode into objout array
                tempintshift=0;
              }else if (Rs1 == 0){;} // do nothing if $0
              else flagError = 1; // invalid operand 
            }
            else if ( (arg2!=NULL) && (strcmp(argreg2, arg2) == 0) ) 
                flagError = 1; // invalid operand
            else  // argument is NULL
              flagError = 2; // invalid number of arguments
		    ;
            if ( (arg3!=NULL) )
            { // valid argument ( not really a register, but using Rs2 anyways )
              Rs2 = atoi(arg3); // convert to int
              if ((Rs2 >= 0) && (Rs2 <= 63))
              { 
                tempintshift = Rs2 << 21; // binary shifting into place
                objout[pc] |= tempintshift; // putting opcode into objout array
                tempintshift=0;
              } else if (Rs1 == 0){;} // do nothing if $0
              else flagError = 1; // invalid operand 
            }
            else  // argument is NULL
              flagError = 2; // invalid number of arguments
		    ; 
          }
//24,25
          else if ( (opcode >= 24) && (opcode <= 25) ) 
          {
            argreg1 = strtok(vars,SEPCOMMA); // reading arg1
            argtemp= strtok(NULL,SEPSPCNL); // reading arg2
            arg2 = strtok(argtemp,SEPPOPEN);
            argreg3 = strtok(NULL,SEPPCLSE);
            
            arg1 = strtok(argreg1,SEPDOLLAR); // remove "$"
            if ( (arg1!=NULL) && (strcmp(argreg1, arg1) != 0) )
            { // valid argument
              i=0; // reset counter 
              arg1 = &arg1[1]; // remove "$"
              Rt = atoi(arg1); // convert to int
              if ((Rt > 0) && (Rt <=31))
              { // valid register
                tempintshift = Rt << 16; // binary shifting into place
                objout[pc] |= tempintshift; // putting opcode into objout array
                tempintshift=0;
              }else if (Rt == 0){;} // do nothing if $0
              else flagError = 1; // invalid operand 
            }
	        else if ( (arg1!=NULL) && (strcmp(argreg1, arg1) == 0) ) 
              flagError = 1; // invalid operand
            else  // argument is NULL
              flagError = 2; // invalid number of arguments
		    ;
            if ( (arg2!=NULL) )
            { // valid argument
              Rs1 = atoi(arg2); // convert to int
              if ((Rs1 > 0) && (Rs1 <=63))
              { // valid register
                tempintshift = Rs1 << 0; // binary shifting into place
                objout[pc] |= tempintshift; // putting opcode into objout array
                tempintshift=0;
              }else if (Rs1 == 0){;} // do nothing if $0
              else flagError = 1; // invalid operand 
            }
            else  // argument is NULL
              flagError = 2; // invalid number of arguments
		    ;
		    arg3 = strtok(argreg3,SEPDOLLAR); // remove "$"
            if ( (arg3!=NULL) && (strcmp(argreg3, arg3) != 0))
            { // valid argument ( not really a register, but using Rs2 anyways )
              Rs2 = atoi(arg3); // convert to int
              if ((Rs2 >= 0) && (Rs2 <= 31))
              { 
                tempintshift = Rs2 << 21; // binary shifting into place
                objout[pc] |= tempintshift; // putting opcode into objout array
                tempintshift=0;
              } else if (Rs1 == 0){;} // do nothing if $0
              else flagError = 1; // invalid operand 
            }
            else if ( (arg3!=NULL) && (strcmp(argreg3, arg3) == 0) ) 
                flagError = 1; // invalid operand
            else  // argument is NULL
              flagError = 2; // invalid number of arguments
		    ; 
          }
          
// J format ||| Rs Rt Address
// 26-27
          else if ( (opcode == 26) || (opcode == 27) ) 
          { 
            argreg1 = strtok(vars,SEPCOMMA); // reading arg1
            argtemp= strtok(NULL,SEPSPCNL); // reading arg2
            arg1 = strtok(argreg1,SEPDOLLAR); // remove "$"
            if ( (arg1!=NULL) && (strcmp(argreg1, arg1) != 0)  )
            { // valid argument
              i=0; // reset counter 
              Rt = atoi(arg1); // convert to int
              if ((Rt > 0) && (Rt <=31))
              { // valid register
                tempintshift = Rt << 16; // binary shifting into place
                objout[pc] |= tempintshift; // putting opcode into objout array
                tempintshift=0;
              }else if (Rt == 0){;} // do nothing if $0
              else flagError = 1; // invalid operand 
            }
	        else if ( (arg1!=NULL) && (strcmp(argreg1, arg1) == 0) ) 
              flagError = 1; // invalid operand
            else  // argument is NULL
              flagError = 2; // invalid number of arguments
		    ;
		    //search tree for matching label
		    if (argtemp!=NULL)
		    {
              Rs2 = searchtree (&pTreeRoot, argtemp);
		      if (Rs2 != -1)
		      {
		        if ((Rs2 >= 0) && (Rs2 <= MEMSIZE))
                { 
                  tempintshift = Rs2 << 0; // binary shifting into place
                  objout[pc] |= tempintshift; // putting opcode into objout array
                  tempintshift=0;
                }
                else // too big
                  flagError = 3; // invalid operand 
              }
              else  // argtemp is not found
              {
                newNode = malloc( sizeof( Node )); // allocate new node space
                newNode->pleft = NULL; // clear pointer
                newNode->pright = NULL; // clear pointer
                newNode->pcval = -1; // saving pc into node
                strcpy(newNode->nodestring, argtemp); // saving string into node

                if (pTreeRoot != NULL)
                {  
                  curptr = pTreeRoot; // reset pointer to start of tree
                  while (curptr!=NULL)
                  { // not reach a leaf
                    prevptr = curptr; // saving ptr
                    if ( strcmp(newNode->nodestring, prevptr->nodestring ) < 0) // before prev
                      curptr = prevptr->pleft; // moving to left
                    else if ( strcmp(newNode->nodestring, prevptr->nodestring ) > 0) // after prev
                      curptr = prevptr->pright; // moving to right
                    else
                    { // error, label already exists
                      break; // error to be printed later
                    } 
                  }; // tmpptr is now pointing to NULL, tmpprevptr = pointer before NULL;
                  if ( strcmp(newNode->nodestring, prevptr->nodestring) < 0) // before prev
                    prevptr->pleft = newNode; // putting new node into place
                  else if ( strcmp(newNode->nodestring, prevptr->nodestring) > 0) // after prev
                    prevptr->pright = newNode; // putting new node into place 
                }
                else
                { // pTreeRoot is empty
                  pTreeRoot = newNode;
                };
                newError = malloc( sizeof( ErrorLine ));
                strcpy(newError->line, argtemp);
                newError->lineval = linecount;
                newError->next = NULL;
                if (pundefcur != NULL)
                {
                  pundefcur->next = newError;
                  pundefprev = pundefcur;
                  pundefcur = pundefcur->next;
                }
                else
                  pundefcur = newError;
                if (pUndefError == NULL)
                  pUndefError = pundefcur;
                flagError=4;
              }
		    }// argument is NULL
		    else 
              flagError = 2;
          }
// 28,29
          else if ( (opcode == 28) ||(opcode == 29) ) 
          { 
            argtemp = strtok(vars,SEPCOMMA); // reading arg1
		    //search tree for matching label
		    if (argtemp!=NULL)
		    {
              Rs1 = searchtree (&pTreeRoot, argtemp);
		      if (Rs1 != -1)
		      {
		        if ((Rs1 >= 0) && (Rs2 <= MEMSIZE))
                { 
                  tempintshift = Rs2 << 0; // binary shifting into place
                  objout[pc] |= tempintshift; // putting opcode into objout array
                  tempintshift=0;
                }
                else // too big
                  flagError = 3; // invalid operand 
              }
              else  // argtemp is not found
              {
                newNode = malloc( sizeof( Node )); // allocate new node space
                newNode->pleft = NULL; // clear pointer
                newNode->pright = NULL; // clear pointer
                newNode->pcval = -1; // saving pc into node
                strcpy(newNode->nodestring, argtemp); // saving string into node

                if (pTreeRoot != NULL)
                {  
                  curptr = pTreeRoot; // reset pointer to start of tree
                  while (curptr!=NULL)
                  { // not reach a leaf
                    prevptr = curptr; // saving ptr
                    if ( strcmp(newNode->nodestring, prevptr->nodestring ) < 0) // before prev
                      curptr = prevptr->pleft; // moving to left
                    else if ( strcmp(newNode->nodestring, prevptr->nodestring ) > 0) // after prev
                      curptr = prevptr->pright; // moving to right
                    else
                    { // error, label already exists
                      break; // error to be printed later
                    } 
                  }; // tmpptr is now pointing to NULL, tmpprevptr = pointer before NULL;
                  if ( strcmp(newNode->nodestring, prevptr->nodestring) < 0) // before prev
                    prevptr->pleft = newNode; // putting new node into place
                  else if ( strcmp(newNode->nodestring, prevptr->nodestring) > 0) // after prev
                    prevptr->pright = newNode; // putting new node into place 
                }
                else
                { // pTreeRoot is empty
                  pTreeRoot = newNode;
                };
                newError = malloc( sizeof( ErrorLine ));
                strcpy(newError->line, argtemp);
                newError->lineval = linecount;
                newError->next = NULL;
                if (pundefcur != NULL)
                {
                  pundefcur->next = newError;
                  pundefprev = pundefcur;
                  pundefcur = pundefcur->next;
                }
                else
                  pundefcur = newError;
                if (pUndefError == NULL)
                  pUndefError = pundefcur;
                flagError=4;
              }
		    }// argument is NULL
		    else 
              flagError = 2;
          }          
          
//30-35
          else if ( (opcode >= 30) && (opcode <= 35) ) 
          { 
            argreg1 = strtok(vars,SEPCOMMA); // reading arg1
            argreg2 = strtok(NULL,SEPCOMMA); // reading arg3            
            argtemp= strtok(NULL,SEPSPCNL); // reading arg3
            
            arg1 = strtok(argreg1,SEPDOLLAR); // remove "$"
            if ( (arg1!=NULL) && (strcmp(argreg1, arg1) != 0) )
            { // valid argument
              Rt = atoi(arg1); // convert to int
              if ((Rt > 0) && (Rt <=31))
              { // valid register
                tempintshift = Rt << 16; // binary shifting into place
                objout[pc] |= tempintshift; // putting opcode into objout array
                tempintshift=0;
              }else if (Rt == 0){;} // do nothing if $0
              else flagError = 1; // invalid operand 
            }
	        else if ( (arg1!=NULL) && (strcmp(argreg1, arg1) == 0) ) 
              flagError = 1; // invalid operand
            else  // argument is NULL
              flagError = 2; // invalid number of arguments
		    ;
		    arg2 = strtok(argreg2,SEPDOLLAR); // remove "$"
            if ( (arg2!=NULL) && (strcmp(argreg2, arg2) != 0) )
            { // valid argument
              Rs1 = atoi(arg2); // convert to int
              if ((Rs1 > 0) && (Rs1 <=31))
              { // valid register
                tempintshift = Rs1 << 21; // binary shifting into place
                objout[pc] |= tempintshift; // putting opcode into objout array
                tempintshift=0;
              }else if (Rs1 == 0){;} // do nothing if $0
              else flagError = 1; // invalid operand 
            }
	        else if ( (arg2!=NULL) && (strcmp(argreg2, arg2) == 0) ) 
              flagError = 1; // invalid operand
            else  // argument is NULL
              flagError = 2; // invalid number of arguments
		    ;
		    //search tree for matching label
		    if (argtemp!=NULL)
		    {
              Rs2 = searchtree (&pTreeRoot, argtemp);
		      if (Rs2 != -1)
		      {
		        if ((Rs2 >= 0) && (Rs2 <= MEMSIZE))
                { 
                  tempintshift = Rs2 << 0; // binary shifting into place
                  objout[pc] |= tempintshift; // putting opcode into objout array
                  tempintshift=0;
                }
                else // too big
                  flagError = 1; // invalid operand 
              }
              else  // argtemp is not found
              {
                newNode = malloc( sizeof( Node )); // allocate new node space
                newNode->pleft = NULL; // clear pointer
                newNode->pright = NULL; // clear pointer
                newNode->pcval = -1; // saving pc into node
                strcpy(newNode->nodestring, argtemp); // saving string into node

                if (pTreeRoot != NULL)
                {  
                  curptr = pTreeRoot; // reset pointer to start of tree
                  while (curptr!=NULL)
                  { // not reach a leaf
                    prevptr = curptr; // saving ptr
                    if ( strcmp(newNode->nodestring, prevptr->nodestring ) < 0) // before prev
                      curptr = prevptr->pleft; // moving to left
                    else if ( strcmp(newNode->nodestring, prevptr->nodestring ) > 0) // after prev
                      curptr = prevptr->pright; // moving to right
                    else
                    { // error, label already exists
                      break; // error to be printed later
                    } 
                  }; // tmpptr is now pointing to NULL, tmpprevptr = pointer before NULL;
                  if ( strcmp(newNode->nodestring, prevptr->nodestring) < 0) // before prev
                    prevptr->pleft = newNode; // putting new node into place
                  else if ( strcmp(newNode->nodestring, prevptr->nodestring) > 0) // after prev
                    prevptr->pright = newNode; // putting new node into place 
                }
                else
                { // pTreeRoot is empty
                  pTreeRoot = newNode;
                }
                newError = malloc( sizeof( ErrorLine ));
                strcpy(newError->line, argtemp);
                newError->lineval = linecount;
                newError->next = NULL;
                if (pundefcur != NULL)
                {
                  pundefcur->next = newError;
                  pundefprev = pundefcur;
                  pundefcur = pundefcur->next;
                }
                else
                  pundefcur = newError;
                if (pUndefError == NULL)
                  pUndefError = pundefcur;
                flagError=4;
              }
		    }
            else // argument is NULL 
              flagError = 2; 
          }
          else //
          // error
          ;
        pc++;  
        }
        else 
        { // ERR cmd and/or vars not specified
         // flagError = 2;
        }
            
      }
      if (flagError != 0)
      {
        newError = malloc( sizeof( ErrorLine ));
        if (flagError == 5)
          strcpy(newError->line, ERR5);
        else if (flagError == 4)
          strcpy(newError->line, ERR4);
        else if (flagError == 3)
          strcpy(newError->line, ERR3);
        else if (flagError == 2)
          strcpy(newError->line, ERR2);
        else if (flagError == 1)
          strcpy(newError->line, ERR1);
        else 
          strcpy(newError->line, ERRX);
        newError->lineval = linecount;
        newError->next = NULL;
        if (pcurError != NULL)
        {
          pcurError->next = newError;
          pprevError = pcurError;
          pcurError = pcurError->next;
        }
        else
          pcurError = newError;
        if (pErrorHead == NULL)
          pErrorHead = pcurError;
        ;
      }	
      linecount++; // increment line counter
    };  
    free(tempstring);
    free(linenocmt);
  }; // end of while

totalPC = pc; // saving final PC count for output

  // now to print the symbol tabel tree to flst
  if (pTreeRoot != NULL)
  { // there are labels declared in the symbol table
    fprintf(flst, "\n \n Symbol Table: \n ------------- \n");
    printtree (&pTreeRoot, flst);
  }// finish printing symbol tabel
  fclose(flst);
}

void printerror (pErrorLine * ptrNode, FILE * ferr)
{
  pErrorLine ptr = * ptrNode;
  while (ptr != NULL)
  {
    fprintf(ferr, "  line %d:  %s \n", ptr->lineval, ptr->line );
    if (ptr->next != NULL)
     ptr = ptr->next;
    else
     ptr = NULL;
  }
}

void printobj(FILE * fobj)
{
  int i = 0;
  
  while ( i < totalPC)
  {
    fprintf(fobj, " %X\t%X ", i, objout[i] );
    fprintf(fobj, "\n");
    i++;
  }
}

/*

*/
