/*
Victor Ng
vn6216@albany.edu
csi402 Spring 2006

*/


#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "bconstants.h"
#include "bstruct_def.h"
#include "bglobals.h"
#include "bprototype.h"



//#include "bfunctions.c"

//constants
static const char * dot = ".\0"; 
static const char * dotASM = "asm\0";
static const char * dotLST = ".lst\0";
static const char * dotERR = ".err\0";
static const char * dotOBJ = ".obj\0";

// start of main
int main(int argc, char *argv[]) 
{
    FILE * finp; // pointer to source file 
    FILE * flst; // pointer to lst file 
    FILE * ferr; // pointer to err file 
    FILE * fobj; // pointer to obj file 
    char oldname[MAXLEN],newname[MAXLEN];
    char *tempname;
    char namelst[MAXLEN], nameerr[MAXLEN], nameobj[MAXLEN];
    int icounter=0; // counter
    
    
    
    // check for command line argument having right amount of arguments 
    if ( (argc == NUMARG) )
    ;
    else
    {   // number of arguments or commands are not correct 
        fprintf(stderr, "Invalid number of arguments. \n");  // prints error message 
        exit(1); // exit due to incorrect number of arguments 
    };
        
      // opening the input file 
      if ( (finp = fopen(argv[1], "r")) == NULL ) 
      {   // open failed 
        fprintf(stderr, "Could not open file '%s' for reading. \n", argv[2]); // prints error 
        exit(1); // exit due to failure in opening the file 
      };

  
  strcpy(oldname,argv[1]);
  icounter=0; // reset counters 
  tempname = strtok(oldname,SEPFNAME);
  newname[0] = '\0';
  strcat(newname, tempname);
  tempname = strtok( NULL, SEPFNAME);
  while ( (tempname!= NULL) && (strcmp(tempname,dotASM)!=0) ) 
  { // extracting the arguments 
    strcat(newname, dot);
    strcat(newname, tempname);
    icounter++;   // increment 'i' 
    tempname = strtok( NULL, SEPFNAME); // extracting argument   
  };
  
  // newname = rootname  
  strcpy(namelst, newname); strcat(namelst, dotLST); // 'rootname'.lst
  strcpy(nameerr, newname); strcat(nameerr, dotERR); // 'rootname'.err
  strcpy(nameobj, newname); strcat(nameobj, dotOBJ); // 'rootname'.obj

  // opening the input file 
    if ( (flst = fopen(namelst, "w")) == NULL ) 
    {   // open failed 
      fprintf(stderr, "Could not open file '%s' for reading. \n", namelst); // prints error 
      exit(1); // exit due to failure in opening the file 
    };

  start();
  read(finp, flst);  

  if ( (pErrorHead != NULL) || (pMultiError != NULL) || (pUndefError != NULL) )
  {
    // opening the error file 
    if ( (ferr = fopen(nameerr, "w")) == NULL ) 
    {   // open failed 
      fprintf(stderr, "Could not open file '%s' for reading. \n", nameerr); // prints error 
      exit(1); // exit due to failure in opening the file 
    };   
    if (pErrorHead != NULL)
    {  
      fprintf(ferr, "Errors detected: \n \n");
      printerror (&pErrorHead, ferr);
    }
    if (pMultiError != NULL)
    {  
      fprintf(ferr, "\n Multiply defined symbol(s): \n \n");
      printerror (&pMultiError, ferr);
    }
    if (pUndefError != NULL)
    {  
      fprintf(ferr, "\n Undefined symbol(s): \n \n");
      printerror (&pUndefError, ferr);
    }
    fclose(ferr);
  }
  else
  {  
    if ( (fobj = fopen(nameobj, "w")) == NULL ) 
    {   // open failed 
      fprintf(stderr, "Could not open file '%s' for reading. \n", nameobj); // prints error 
      exit(1); // exit due to failure in opening the file 
    };
    
    printobj(fobj);
    fclose(fobj);
  }
  
  return 0;
}


