/*
Victor Ng
vn6216@albany.edu
csi402 Spring 2006

*/


#include <stdio.h>
#include <stdlib.h>

#include "aconstants.h"
#include "astruct_def.h"
#include "aglobals.h"
#include "aprototype.h"

//  #include "afunctions.c"

// used for command line comparison
static const char * cO = "-o"; // -o
// default executible name
static const char * cEXECNAME = "a.exe"; // a.exe

int main(int argc, char *argv[]) 
{
  FILE * finp; // pointer to file to be read 
  FILE * foutp; // pointer to output file 
  
  int flagexec = 0; // flag for specified executible output
  
  // checking for parameters
  if(argc == NUMARGA) 
  ;
  else if ( (argc == NUMARGB) && (argv[2] != NULL) && (strcmp(argv[2], cO) == 0) )
    flagexec = 1; // set flag to true for executible  
  else
    {   // number of arguments or commands are not correct 
        fprintf(stderr, "Invalid number of arguments and/or commands. \n");  // prints error message 
        exit(1); // exit due to incorrect cmd line 
    };
    
  if ( (finp = fopen(argv[1], "r")) == NULL ) // open config file for reading
  {   // open failed 
    fprintf(stderr, "Could not open file '%s' for reading. \n", argv[1]); // prints error 
    exit(1); // exit due to failure in opening the file 
  };// open successful
  
  if (flagexec == 1) // if executible name is specified
  { // foutp points to argv[3], the specified executible output
    if ( (finp = fopen(argv[3], "w")) == NULL )  // use specified name
    {   // open failed 
      fprintf(stderr, "Could not open file '%s' for reading. \n", argv[3]); // prints error 
      exit(1); // exit due to failure in opening the file 
    };// open successful
  }
  else // executible name is not specified
  { // foutp points to default executible name 
    if ( (foutp = fopen(cEXECNAME, "w")) == NULL ) // use default name
    {   // open failed 
      fprintf(stderr, "Could not open file '%s' for reading. \n", cEXECNAME); // prints error 
      exit(1); // exit due to failure in opening the file 
    };// open successful
  }
  
  readcfgfile(finp); // read the config file
  fclose(finp); // close the config file
  readobjects ( foutp ); // read and output the module
  fclose(foutp); // close the module file
  
  return 0; // end of program
};
