/*
Victor Ng
vn6216@albany.edu
csi402 Spring 2006

*/


#include <stdio.h>
#include <stdlib.h>

#include <unistd.h> // read, write
#include <fcntl.h> // open, close 
#include <sys/stat.h> // stat

#include "bconstants.h"
#include "bstruct_def.h"
#include "bglobals.h"
#include "bprototype.h"

#include "bfunctions.c"

// used for command line comparison
static const char * cC = "-c"; // -c
static const char * cX = "-x"; // -x


int main(int argc, char *argv[]) 
{
  int finp; // pointer to file to be read 
  int foutp; // pointer to output file 

  struct stat statbuf; // stat struct buffer
  unsigned int filesize; // file size 
  unsigned int cmdfilecount; // number of input files (starting from 1)
  unsigned int shifted; // temp output for shifting bits
  int i=0, j=0; // counter

  unsigned int filenamelen=0; // length of file name
  int size;
  
  pNode newNode; // pointer to a new node
  pNode pCurrent; // pointer to the current node
  
  // checking for parameters
    if( (strcmp(argv[1], cC) == 0) && (argc > NUMARGc-1) )
      cmdfilecount = argc - 3; // off set of -1 from argc
    else if ( (strcmp(argv[1], cX) == 0) && (argc == NUMARGc) )
      cmdfilecount = 0;
    else
    {   // number of arguments or commands are not correct 
        fprintf(stderr, "Invalid number of arguments for command '%s'. \n", argv[1]);  // prints error message 
        exit(1); // exit due to incorrect number of arguments 
    };
    


// start program
// -c
  if (strcmp(argv[1], cC) == 0)
  { // read files into argv[2]
    // opening the input file 
    if ( (foutp = open(argv[2], O_WRONLY | O_CREAT, PERM)) == -1 ) 
    { // open failed 
      fprintf(stderr, "Could not open file '%s' for writing. \n", argv[2]); // prints error 
      exit(1); // exit due to failure in opening the file 
    };
    
    shifted = cmdfilecount << SHIFTINT; //shifting left int by SHIFTINT to put into 1 byte
    write ( foutp, &shifted, 1); // writing number of files
    
    i=3; //setting i = first file name in cmd parameters
    while (i < argc)
    { // while files exists in the cmd line
      if (stat(argv[i],&statbuf) == -1)
      { // file cannot be stat
        fprintf(stderr, "Couldn't stat file 'arg %d'. \n", i );
        exit(1); // exit due to failure in opening the file 
      }; //open successful
      filesize = statbuf.st_size;
      filenamelen = strlen(argv[i]); // getting length of filename
      shifted = filenamelen << SHIFTINT; //shifting left int by SHIFTINT to put into 1 byte
      write ( foutp, &shifted, 1 ); // writing the length of filename
      write ( foutp, argv[i], filenamelen ); // writing filename
      write ( foutp, &filesize, 4 ); // writing filename
      
      i++; // increment counter i
    }
    // info records are done, now to read the files and put into foutp
    i=3; // reset counter to start of input files in cmd line
    while (i < argc)
    { // while files exists in the cmd line
      if ( (finp = open(argv[i], O_RDONLY)) == -1 ) 
      { // open failed 
        fprintf(stderr, "Could not open file 'arg %d' for reading. \n", i); // prints error 
        exit(1); // exit due to failure in opening the file 
      };  //open successful
      readinfile( foutp, finp); // read the finp and output in foutp
      close(finp); // close finp
      i++; // increment counter i
    }
    close(foutp); // close foutp
  }
// -x
  else if (strcmp(argv[1], cX) == 0)
  { // read argv[2]
    // opening the output file 
    if ( (finp = open(argv[2], O_RDONLY)) == -1 ) 
    { // open failed 
      fprintf(stderr, "Could not open file '%s' for reading. \n", argv[2]); // prints error 
      exit(1); // exit due to failure in opening the file 
    };  
    
    i=0; // reset counter
    read (finp, &cmdfilecount, 1); // read number of files
    printf("%d, ", cmdfilecount);
    while (i < cmdfilecount)
    { // while there exists files
      newNode = malloc( sizeof( Node )); // allocate new node space
      read (finp, &filenamelen, 1); // read the file name length
printf("%d, ", filenamelen);
      read (finp, newNode->filename, filenamelen); // read the file name
      newNode->filename[filenamelen] = '\0';
printf("%s, ", newNode->filename);
      read (finp, &size, 4); // read the file name
      newNode->filesize = /*atoi(*/size/*)*/;
printf("%d, ", newNode->filesize);
      newNode->next = NULL; // setting NULL for next pointer
      
      if (pHeader == NULL) // if pHeader is NULL
        pHeader = newNode; // no nodes exist, this is first node
      else // nodes already exist
        pCurrent->next = newNode; // put newNode at end of linked list
      pCurrent = newNode; // increment new pointer.
      i++; // increment counter i
    }// all information has been read, now to read the file from finp
    
    readarchivefile ( cmdfilecount, finp );   
    
  }
  else
  ;

  return 0; // end of program
};
