/*
Victor Ng
vn6216@albany.edu
csi402 Spring 2006

*/


#include <stdio.h>
#include <stdlib.h>

#include <unistd.h> // read, write
#include <fcntl.h> // open, close 

#include "bconstants.h"
  #include "bstruct_def.h"
#include "bexterns.h"


void readarchivefile ( FILE * finp )
{
  FILE * foutp; // file out
  int i=0, j=0; // counters
  char buffer; // buffer char
  
  unsigned int filecount = 0; // number of files
  unsigned int shifted=0; // temp output for shifting bits
  unsigned int filenamelen = 0; // length of file name 
  unsigned int size; // temp store for file size
  
  pNode newNode; // pointer to a new node
  pNode pCurrent; // pointer to the current node
  
  i=0; // reset counter
  fread ( (void * ) &shifted, 1, 1, finp); // read number of files
  filecount = shifted >> SHIFTINT; // shift the number into place
  
  while (i < filecount)
  { // while there exists files
    newNode = malloc( sizeof( Node )); // allocate new node space
    fread ( (void * ) &shifted, 1,1,finp); // read the file name length
    filenamelen = shifted >> SHIFTINT;
    fread ( (void * ) newNode->filename, filenamelen * sizeof(char), 1, finp); // read the file name
    newNode->filename[filenamelen] = '\0'; // adding NULL char to end of file
    fread ( (void * )&size, sizeof(unsigned int), 1, finp); // read the file size
    newNode->filesize = size; // saving the size into node
    newNode->next = NULL; // setting NULL for next pointer
    
    if (pHeader == NULL) // if pHeader is NULL
      pHeader = newNode; // no nodes exist, this is first node
    else // nodes already exist
      pCurrent->next = newNode; // put newNode at end of linked list
    pCurrent = newNode; // increment new pointer.
    i++; // increment counter i
  }// all information has been read, now to read the file from finp
  
  pCurrent = pHeader;
  i=0; // reset counter
  while ( (i < filecount) && (pCurrent != NULL) )
  { // while there exists files in the linked list      
    if ( (foutp = fopen(pCurrent->filename, "w")) == NULL ) 
    { // open failed 
      fprintf(stderr, "Could not open file '%s' for writing. \n", pCurrent->filename); // prints error 
      exit(1); // exit due to failure in opening the file 
    };
    j=0; // reset counter j
    while (j < pCurrent->filesize)
    { // while file size is not reached
      fread(&buffer, 1,1,finp); // read 1 byte from finp
      fwrite (&buffer, 1,1,foutp); // write 1 byte into foutp
      j++; // increment counter j
    }// end of this file
    fclose(foutp); // close foutp
    if (pCurrent->next != NULL) // checking for next node in list
      pCurrent = pCurrent->next; // next node exists
    else // end of list
      pCurrent = NULL; // pCurrent is NULL
    i++; // increment counter i for next file
  };// end of file output loop
  
};


void readinfile( FILE * foutp, FILE * finp )
{
  char buffer; // buffer char
  
  while( (fread( &buffer,1, 1,finp)) == 1 ) // read 1 byte from finp
  { // while finp is not end of file
    fwrite ( &buffer, 1,1,foutp); // write 1 byte into foutp
  };
  
};




