/*
Victor Ng
vn6216@albany.edu
csi402 Spring 2006

*/


#include <stdio.h>
#include <stdlib.h>

#include <unistd.h> // read, write
#include <fcntl.h> // open, close 
#include <sys/stat.h> // stat

#include "bconstants.h"
#include "bstruct_def.h"
#include "bglobals.h"
#include "bprototype.h"

//  #include "bfunctions.c"

// used for command line comparison
static const char * cC = "-c"; // -c
static const char * cX = "-x"; // -x


int main(int argc, char *argv[]) 
{
  FILE * finp; // pointer to file to be read 
  FILE * foutp; // pointer to output file 
  
  struct stat statbuf; // stat struct buffer 
  unsigned int filesize=0; // file size 
  unsigned int cmdfilecount=0; // number of input files (starting from 1) 
  unsigned int shifted=0; // temp output for shifting bits 
  unsigned int i=0; // counter 
  
  unsigned int filenamelen = 0; // length of file name 
  
  // checking for parameters
  if( (argv[1] != NULL ) && (strcmp(argv[1], cC) == 0) && (argc > NUMARGc-1) )
    cmdfilecount = argc - 3; // off set of -1 from argc
  else if ( (argv[1] != NULL ) && (strcmp(argv[1], cX) == 0) && (argc == NUMARGc) )
    cmdfilecount = 0;
  else
  {   // number of arguments or commands are not correct 
    fprintf(stderr, "Invalid number of arguments for command '%s'. \n", argv[1]);  // prints error message 
    exit(1); // exit due to incorrect number of arguments 
  };
    


// start program
// -c
  if (strcmp(argv[1], cC) == 0)
  { // read files into argv[2]
    // opening the input file 
    if ( (foutp = fopen(argv[2], "w")) == NULL ) 
    { // open failed 
      fprintf(stderr, "Could not open file '%s' for writing. \n", argv[2]); // prints error 
      exit(1); // exit due to failure in opening the file 
    };
    
    shifted = cmdfilecount << SHIFTINT; //shifting left int by SHIFTINT to put into 1 byte
    fwrite ( &shifted, 1, 1, foutp); // writing number of files
    
    i=3; //setting i = first file name in cmd parameters
    while (i < argc)
    { // while files exists in the cmd line
      if (stat(argv[i],&statbuf) == -1)
      { // file cannot be stat
        fprintf(stderr, "Couldn't stat file 'arg %d'. \n", i );
        exit(1); // exit due to failure in opening the file 
      }; //open successful
      filesize = statbuf.st_size;
      filenamelen = strlen(argv[i]); // getting length of filename
      shifted = filenamelen << SHIFTINT; //shifting left int by SHIFTINT to put into 1 byte
      fwrite ( &shifted, 1, 1, foutp); // writing the length of filename
      fwrite ( argv[i], filenamelen * sizeof(char), 1, foutp ); // writing filename
      fwrite ( &filesize, sizeof (unsigned int), 1, foutp ); // writing filename
      
      i++; // increment counter i
    }
    // info records are done, now to read the files and put into foutp
    i=3; // reset counter to start of input files in cmd line
    while (i < argc)
    { // while files exists in the cmd line
      if ( (finp = fopen(argv[i], "r")) == NULL ) 
      { // open failed 
        fprintf(stderr, "Could not open file 'arg %d' for reading. \n", i); // prints error 
        exit(1); // exit due to failure in opening the file 
      };  //open successful
      readinfile( foutp, finp); // read the finp and output in foutp
      fclose(finp); // close finp
      i++; // increment counter i
    }
    fclose(foutp); // close foutp
  }
// -x
  else if (strcmp(argv[1], cX) == 0)
  { // read argv[2]
    // opening the output file 
    if ( (finp = fopen(argv[2], "r")) == NULL ) 
    { // open failed 
      fprintf(stderr, "Could not open file '%s' for reading. \n", argv[2]); // prints error 
      exit(1); // exit due to failure in opening the file 
    };  
    readarchivefile ( finp );   
    fclose(finp); // close finp
  }
  else // should not happen
    fprintf(stderr, "Invalid command parameters. \n");;
  return 0; // end of program
};
