/*
Victor Ng
vn6216@albany.edu
csi402 Spring 2006

*/

#include <stdio.h>
#include <stdlib.h>
#include <sys/types.h>
#include <dirent.h>
#include <sys/stat.h>
#include <string.h>
#include <time.h>

#define NUMARGA 2 // Number of arguments to expect without executible specified 
#define MAXSIZE 255 // size for string used for file/path name
#define TIMESIZE 80 // size for string used for time

int match (const char *str);
/* see if the string starts with the hidden parameter, returns 1 if true, otherwise 0 */

char *timeformat (const struct tm *tp);
/* returns the time in MMM DD YYYY string */

static const char * cHid = "."; // hidden prefix
static const char * cCD = ".."; // current directory
//static const char * cBS = "??/"; // current directory

int match (const char *str);
char *timeformat (const struct tm *tp);

int main(int argc, char *argv[]) 
{
  DIR *dp = NULL; // directory stream pointer 
  struct dirent *d; // directory stream pointer 
  struct stat statbuf; // stat buffer
  struct tm *tp;
  char fullpath[MAXSIZE];
  
  if(argc == NUMARGA) 
  ; // number of arguments match
  else
  { // number of arguments or commands are not correct 
    fprintf(stderr, "Invalid number of arguments. \n");  // prints error message 
    exit(1); // exit due to incorrect cmd line 
  };
    
  if ((dp = opendir (argv[1])) == NULL) // check if directory can be opened
  { // directory cannot be opened
    fprintf(stderr, "Cannot open specified directory. \n");  // prints error message 
    exit(1); // exit  
  }; // directory opened

  
  while( d = readdir(dp) ) // while directory struct pointer is not NULL
  { // files exist in the directory
//    if (d->d_ino == 0) // parent directory ".."
//      continue;  // continue with loop
    if (match(d->d_name))
    { // name matches the hidden prefix
      strcpy(fullpath, argv[1]);
      strcat(fullpath, "/");
      strcat(fullpath, d->d_name);

      if(stat(fullpath,&statbuf) == -1)
      { // stat filed
        fprintf(stderr, "Cannot stat '%s'. \n",d->d_name);  // prints error message 
        continue; // continue with loop
      }; // file stat sucessful

      tp = localtime(&statbuf.st_mtime);
      // print the info about the file
      printf("%s  %d  %s \n", d->d_name, statbuf.st_size, timeformat(tp) );
      // print sucessful

    };
    // next file in directory
  };
  // end of directory
  closedir(dp); // close directory
  return 0; // end of program
};

int match (const char *str)
{
  char temp[2];

  if (strcmp(str,cCD) == 0) // name matches the ".." for parent directory
    return 0; // return 0
  if (strcmp(str,cHid) == 0) // name matches the "." for just "."
    return 0; // return 0

// string is not "." or ".."
  strncpy(temp, str, 1); // removing all other characters but the first one
  temp[1]='\0'; // inserting NULL char to end of string
  if (strcmp(temp,cHid) == 0) // name matches the "." for hidden file prefix
    return 1; // return 1
  else // name doesn't match the hidden prefix
    return 0; // return 0
}

char *timeformat (const struct tm *tp)
{
  static char time_buffer[TIMESIZE]; // temp string
  size_t len; // length written with strftime
  len = strftime( time_buffer, TIMESIZE, "%b %d %Y", tp); // format MMM DD YYYY
  
  if (len == 0) // len = 0, strftime failed
    return "Unknown Modified Time"; // Error message
  else
    return time_buffer; // return the string
}

