/*
Victor Ng
vn6216@albany.edu
csi402 Spring 2006

*/


#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h> 
#include <fcntl.h>
#include <errno.h>

#include "bsconsts.h"
  #include "bcstructs.h" //fifo struct
#include "bcexts.h"

/* pointers to commands for use with 'strcmp' */       
static const char * cADDC = "addc"; // addc
static const char * cDRPC = "drpc"; // drpc
static const char * cWDRW = "wdrw"; // wdrw
static const char * cTCRE = "tcre"; // tcre
static const char * cNEWC = "newc"; // newc
static const char * cCSCH = "csch"; // csch
static const char * cCCRE = "ccre"; // ccre
static const char * cGSCH = "gsch"; // gsch
static const char * cGCRE = "gcre"; // gcre
//static const char * cEXIT = "exit"; // exit

void fatal_exit()
{
  fd2server.exit = 1; // setting exit = 1
  if( (write(cmdfd, &fd2server, sizeof( struct cmdfifodata)) == -1) )// writing fifo to server
    fprintf(stderr, "Client: Cannot write fifo, send exit failed. \n"); // write failed
  close(cmdfd); // closing fifo to server
  close(cltfd); // closing fifo to client
}


void processcmd (FILE * cmdfile, FILE * logfile)
{
  char *tempcmd; // temp variable for command reading
  char *tempname; // temp variable for name reading
  char *tempinfo; // temp variable for course info reading
  char buf; // buffer
  int nr; // number of bytes read

  
  while(!feof(cmdfile))
  {
    if (feof(cmdfile))
     break;
    
    // reset the struct
    strcpy(fd2server.cmd,"\0");
    strcpy(fd2server.name,"\0");
    fd2server.courseid = 0;
    fd2server.credits = 0; 
    strcpy(fd2server.courseinfo,"\0");  
    fd2server.exit = 0; // resetting the exit command
    
    tempcmd = (char *) malloc(CMDLEN * sizeof(char));  // allocating memory of 'MAXLEN' characters
    tempname = (char *) malloc(SNAMELEN * sizeof(char));  // allocating memory of 'MAXLEN' characters
    tempinfo = (char *) malloc(CINFOLEN * sizeof(char));  // allocating memory of 'MAXLEN' characters
    
    fscanf( cmdfile, "%s", tempcmd ); // read student name
    
    if ( strlen(tempcmd) > CMDLEN-1 )
    { // command is invalid
      strncpy( fd2server.cmd, tempcmd, CMDLEN); // cut the command if it was too long
    }
    else 
    {
      
      strcpy( fd2server.cmd, tempcmd); // copy the command into the fifo struct
      if ( (strcmp(tempcmd, cADDC) == 0) || (strcmp(tempcmd, cDRPC) == 0) )
      { // addc drpc
        fscanf( cmdfile, "%s", tempname ); // read name
        strcpy(fd2server.name, tempname); // copy course info
        fscanf( cmdfile, "%d", &fd2server.courseid ); // read course id
      }
      else if( (strcmp(tempcmd, cWDRW) == 0) || (strcmp(tempcmd, cTCRE) == 0) )
      { // wdrw tcre
        fscanf( cmdfile, "%s", tempname ); // read name
        strcpy(fd2server.name, tempname); // copy course info
      }
      else if( (strcmp(tempcmd, cNEWC) == 0) )
      { // newc
        fscanf( cmdfile, "%d", &fd2server.courseid ); // read course id
        fscanf( cmdfile, "%d", &fd2server.credits ); // read number of credits
        fscanf( cmdfile, "%s", tempinfo ); // read course info
        strcpy(fd2server.courseinfo, tempinfo); // copy course info
      }
      else if( (strcmp(tempcmd, cCSCH) == 0) )
      { // csch
        fscanf( cmdfile, "%d", &fd2server.courseid ); // read course id
        fscanf( cmdfile, "%s", tempinfo ); // read course info
        strcpy(fd2server.courseinfo, tempinfo); // copy course info
      }
      else if( (strcmp(tempcmd, cCCRE) == 0) )
      { // ccre
        fscanf( cmdfile, "%d", &fd2server.courseid ); // read course id
        fscanf( cmdfile, "%d", &fd2server.credits ); // read number of credits
      }
      else if( (strcmp(tempcmd, cGSCH) == 0) || (strcmp(tempcmd, cGCRE) == 0) )
      { // gsch gcre
        fscanf( cmdfile, "%d", &fd2server.courseid ); // read course id
      }
      else
      { // invalid cmd
        
      };
    };// end of line
    do
    {// read till "\n"
      buf = fgetc(cmdfile);
    }while(buf != '\n');
fprintf(stderr, "client : end of line \n"); // read failed
    // sending command to server
    if( (write(cmdfd, &fd2server, sizeof( struct cmdfifodata )) == -1) )
    { // write failed
      fatal_exit(); // close all fifos and error msg
      exit(1); // exit due to failure in writing fifo
    }; // data written sucessfully
    
    // read reply from server
    while( (nr = read(cltfd, &fd2client, sizeof( struct returnfifodata ))) == 0);
    // keep reading till something is read
    if ( (nr == -1) || nr!=sizeof( struct returnfifodata ) )
    {
      fprintf(stderr, "Client: Read fifo filed.\n"); // read failed
      fatal_exit(); // close all fifos and error msg
      exit(1); // exit due to failure in reading reply from server 
    }; // data returned sucessfully
    
    
    if (fd2client.seq == -1)
    {
      ;
    }
    else
    {
      fprintf( logfile, "%d  ", fd2client.seq ); // print sequence number
      fprintf( logfile, "%s  ", fd2client.cmd ); // print command
      fprintf( logfile, "%d  ", fd2client.status ); // print status 1/0
      
      if ( (strcmp(fd2client.cmd, cTCRE) == 0) || (strcmp(fd2client.cmd, cGCRE) == 0) )
      { // tcre gcre
        fprintf( logfile, "%d ", fd2client.returnint ); // print return value
      }
      else if (strcmp(fd2client.cmd, cGSCH) == 0)
      { // gsch 
        fprintf( logfile, "%s ", fd2client.returnstr ); // print return string
      }
      else if ( fd2client.invalidcmd == 1)
      { // command was invalid
        fprintf( logfile, "%s ", fd2client.returnstr ); // print return string
      }
      else
      { // do nothing
        ;
      }
      fprintf( logfile, "\n"); // newline
    };  
    free(tempcmd); // free memory
    free(tempname); // free memory
    free(tempinfo); // free memory
  };// end of file, end of loop
  
  fprintf(stderr, "Client: EOF \n "); // read failed
  fd2server.exit = 1; // setting exit to 1
  strcpy(fd2server.cmd,"\0");
  strcpy(fd2server.name,"\0");
  fd2server.courseid = 0;
  fd2server.credits = 0; 
  strcpy(fd2server.courseinfo,"\0");  
  // sending command to server
  if( (write(cmdfd, &fd2server, sizeof( struct cmdfifodata )) == -1) )
  { // write failed
    fatal_exit(); // close all fifos and error msg
    exit(1); // exit due to failure in writing fifo
  }; // data written sucessfully
  
  
  
}


