/*
Victor Ng
vn6216@albany.edu
csi402 Spring 2006

*/


#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h> 
#include <fcntl.h>
#include <errno.h>

#include "bsconsts.h"
  #include "bsstructs.h"
  #include "bcstructs.h" //fifo struct
#include "bsexts.h"

/* pointers to commands for use with 'strcmp' */       
static const char * cADDC = "addc"; // addc
static const char * cDRPC = "drpc"; // drpc
static const char * cWDRW = "wdrw"; // wdrw
static const char * cTCRE = "tcre"; // tcre
static const char * cNEWC = "newc"; // newc
static const char * cCSCH = "csch"; // csch
static const char * cCCRE = "ccre"; // ccre
static const char * cGSCH = "gsch"; // gsch
static const char * cGCRE = "gcre"; // gcre
//static const char * cEXIT = "exit"; // exit

static const char * cERR = "Error"; // "Error" for use with "gsch"

void fatal_exit()
{
  fd2client.seq = -1; // error
  if( (write(cltfd, &fd2server, sizeof( struct returnfifodata)) == -1) )// writing fifo to server
    fprintf(stderr, "Server: Cannot write fifo, send exit failed. Fatal Error. \n"); // write failed
  close(cmdfd); // closing fifo to server
  close(cltfd); // closing fifo to client
}

void readdb (char * filename)
{
  FILE * finidb; // pointer to initial database
  int i,j; // counters
  int tempint; // temporary variable
  pNode newNode; // pointer to newly created node for linked list
  pNode pCurrent = NULL; // pointer to current node in linked list
  
  // opening the initial database file 
  if ( (finidb = fopen(filename, "r")) == NULL ) 
  {   // open failed 
    fprintf(stderr, "Server: Could not open file '%s' for reading. \n", filename); // prints error message 
    fatal_exit(); // close all fifos and error msg
    exit(1); // exit due to failure in opening the file 
  }; // open sucessful
  
  
  fscanf( finidb, "%d", &NumofStudents); // read the number of students
  i=0; //reset counter
  while (i < NumofStudents)
  {// while there are still students to read
    fscanf( finidb, "%s", Student[i].name ); // read student name
    fscanf( finidb, "%d", &tempint ); // read number of courses
    Student[i].numcourse = tempint; // save the number of courses into the student table
    j=0; // reset counter
    pCurrent = NULL;
    while ( j < tempint )
    { // while there are courses to read    
      newNode = malloc( sizeof( Node )); // allocate new node space
      newNode->next = NULL; // setting NULL to next pointer
      fscanf( finidb, "%d", &newNode->coursenum); // store course number into node
      if (Student[i].first == NULL) // if first node is NULL
        Student[i].first = newNode; // no nodes exist, this is first node
      else // nodes already exist
        pCurrent->next = newNode; // put newNode at end of linked list
      pCurrent = newNode; // increment new pointer.
      
      j++; // increment counter for course nodes
    }; // finish reading courses 
    i++; // increment counter for student table
  }; // finish reading student info
  
  fscanf( finidb, "%d", &NumofCourses); // read the number of courses
  i=0;
  while (i < NumofCourses)
  { // while there are still course infomation to be read
    fscanf( finidb, "%d", &Course[i].course ); // read course number
    fscanf( finidb, "%d", &Course[i].credits ); // read number of enrolled
    fscanf( finidb, "%s", Course[i].courseinfo ); // read course infomation
    
    i++; // increment counter for course table  
  };
  
  fclose(finidb); // close the initial database file
  
}

int findcourseid( int courseid)
{
  int i; // counter
  
  i=0;//reset counter
  while (i < NumofCourses)
  { // while there are still course infomation
    if (courseid == Course[i].course)
      return 1; // return 1 for courseid found
    i++; // increment counter for course table  
  };//end of loop
  return 0; // courseid not found
}

int getcoursecredit( int courseid )
{
  int i; // counter
  
  i=0;//reset counter
  while (i < NumofCourses)
  { // while there are still course infomation
    if (courseid == Course[i].course)
      return Course[i].credits; // return number of credits for the course
    i++; // increment counter for course table  
  };//end of loop
  return -1; // courseid not found
}

void processfifo()
{
  int i; // counters
  pNode newNode; // pointer to newly created node for linked list
  pNode pCurrent = NULL; // pointer to current node in linked list
  pNode pPrev = NULL; //pointer to previous node in linked list

  //reset fifostruct to client
  strcpy(fd2client.cmd, "\0"); ;
  strcpy(fd2client.returnstr, "\0");
  fd2client.returnint = 0;
  fd2client.seq = 0;
  fd2client.status = 0;
  
  fprintf(stderr, "| %s ", fd2server.cmd);
  
  if (fd2server.exit == 1)
  {
    ;
  }
  else
  {
    if (strcmp(fd2server.cmd, cADDC) == 0)
    { // addc
fprintf(stderr, " %s ", fd2server.name);
      if (findcourseid(fd2server.courseid) == 1)
      { // courseid exists
        i=0; // reset counter
        while (i < NumofStudents)
        {// names exist in database
          if (strcmp(fd2server.name, Student[i].name)==0)
          { // found name
            Student[i].numcourse++; // increment the course count 
            break; // break out of loop, no need to check any further, name is found
          };
          i++; // increment counter
        }; // end of loop, name not found
        if (i == NumofStudents)
        { // create new entry for student
          strcpy(Student[i].name, fd2server.name); // save name to end of struct
          Student[i].numcourse = 1; // courses registered = 1
          NumofStudents++; // increment the number of students in the database
          };
        newNode = malloc( sizeof( Node )); // allocate new node space
        newNode->next = NULL; // setting NULL to next pointer
        newNode->coursenum = fd2server.courseid; // store course number into node
        if (Student[i].first == NULL) // if first node is NULL
          Student[i].first = newNode; // no nodes exist, this is first node
        else // nodes already exist
        { // 
          pCurrent=Student[i].first; // set pointer to first node in linked list
          while (pCurrent->next!=NULL) // if not at last node
            pCurrent=pCurrent->next; // travel to last node
          pCurrent->next = newNode; // put newNode at end of linked list
          pCurrent = newNode; // increment new pointer.
        }; // data processed sucessfully
        fd2client.status = 1; // set return command status
      }
      else
      { // courseid does not exists
        fd2client.status = 0; // set return command status
      };
    }
    else if (strcmp(fd2server.cmd, cDRPC) == 0)
    { // drpc
fprintf(stderr, " %d ", fd2server.courseid);
      i=0; // reset counter
      fd2client.status = 0; // set return command status
      while (i < NumofStudents)
      {// names exist in database
        if (strcmp(fd2server.name, Student[i].name)==0)
        { // found name
          if (Student[i].first == NULL) // if first node is NULL
            pCurrent=NULL; // no nodes exist
          else
          { // nodes exists
            pCurrent=Student[i].first; // set pointer to first node in linked list
            pPrev = NULL; // pPrev == NULL, meaning this is the first node
          };
          break; // break out of loop, no need to check any further, name is found
        };
        i++; // increment counter
      }; // end of loop, name not found
      while(pCurrent!=NULL)
      { // there are courseid's
        if (pCurrent->coursenum == fd2server.courseid)
        { // course id matches for drop
          Student[i].numcourse--; // decrement count in number of courses
          if ( (pPrev==NULL) && (pCurrent->next!=NULL) ) // this is the first node, next node exists
            Student[i].first = pCurrent->next;
          else if ( (pPrev!=NULL) && (pCurrent->next!=NULL) ) // this is not the first node, next node exists
            pPrev->next = pCurrent->next;
          else if ( (pPrev!=NULL) && (pCurrent->next==NULL) ) // this is not the first node, next node does not exists
            pPrev->next = NULL;
          free(pCurrent); // free the memory for the node
          fd2client.status = 1; // set return command status
        }
        if (pCurrent->next != NULL) // if next node exists
          pCurrent = pCurrent->next; // next is current node
        else
          pCurrent = NULL; // no more nodes
      }; // end of while
    }
    else if (strcmp(fd2server.cmd, cWDRW) == 0)
    { // wdrw 
fprintf(stderr, " %s ", fd2server.name);    
      i=0; // reset counter
      fd2client.status = 0; // set return command status
      while (i < NumofStudents)
      {// names exist in database
        if (strcmp(fd2server.name, Student[i].name)==0)
        { // found name
          Student[i].numcourse = 0; // setting number of courses = 0
          fd2client.status = 1; // set return command status
          if (Student[i].first == NULL) // if first node is NULL
            pCurrent=NULL; // no nodes exist
          else
          { // nodes exists
            pCurrent=Student[i].first; // set pointer to first node in linked list
            pPrev = NULL; // pPrev == NULL, meaning this is the first node
          };
          Student[i].first = NULL;
          break; // break out of loop, no need to check any further, name is found
        };
        i++; // increment counter
      }; // end of loop, name not found
      while (pCurrent!=NULL)
      { // there are nodes that exists
        pPrev=pCurrent; // prev pointer = current pointer
        if (pCurrent->next != NULL) // if next node exists
          pCurrent = pCurrent->next; // next is current node
        else
          pCurrent = NULL; // no more nodes
        free(pPrev); // free the current node
      }; // end of free nodes, memory returned
    }
    else if (strcmp(fd2server.cmd, cTCRE) == 0)
    { // tcre
fprintf(stderr, " %s ", fd2server.name);     
      fd2client.status = 0; // set return command status
      fd2client.returnint=-1; // set return command value
      i=0; // reset counter
      fd2client.status = 0; // set return command status
      while (i < NumofStudents)
      {// names exist in database
        if (strcmp(fd2server.name, Student[i].name)==0)
        { // found name
          fd2client.returnint = 0; // set return command value
          fd2client.status = 1; // set return command status
          if (Student[i].first == NULL) // if first node is NULL
            pCurrent=NULL; // no nodes exist
          else
          { // nodes exists
            pCurrent=Student[i].first; // set pointer to first node in linked list
            pPrev = NULL; // pPrev == NULL, meaning this is the first node
          };
          Student[i].first = NULL;
          break; // break out of loop, no need to check any further, name is found
        };
        i++; // increment counter
      }; // end of loop, name not found
      while (pCurrent!=NULL)
      { // there are nodes that exists
        fd2client.returnint += getcoursecredit(pCurrent->coursenum);
        if (pCurrent->next != NULL) // if next node exists
          pCurrent = pCurrent->next; // next is current node
        else
          pCurrent = NULL; // no more nodes
      }; // end of free nodes, memory returned
    }
    else if (strcmp(fd2server.cmd, cNEWC) == 0) 
    { // newc
fprintf(stderr, " %s ", fd2server.name);     
      fd2client.status = 0; // set return command status
      if (findcourseid( fd2server.courseid) == 0)
      { // course doesn't exists
        fd2client.status = 1; // set return command status
        NumofCourses++; // increment the total number of courses
        i = NumofCourses; // set counter
        Course[i].course = fd2server.courseid; // save courseid into database
        Course[i].credits = fd2server.credits; // save course credits into database
        strcpy(Course[i].courseinfo, fd2server.courseinfo); // copy courseinfo into database
      }
    }
    else if (strcmp(fd2server.cmd, cCSCH) == 0) 
    { // csch
fprintf(stderr, " %d ", fd2server.courseid);         
      fd2client.status = 0; // set return command status
      i=0;//reset counter
      while (i < NumofCourses)
      { // while there are still course infomation
        if (Course[i].course == fd2server.courseid)
        { // courseid found
          fd2client.status = 1; // set return command status
          strcpy(Course[i].courseinfo, fd2server.courseinfo); // modify courseinfo into database
          break; // break out of loop, no need to check any further, course is found
        }; 
        i++; // increment counter
      };//end of loop
    }
    else if (strcmp(fd2server.cmd, cCCRE) == 0) 
    { // ccre
fprintf(stderr, " %d ", fd2server.courseid);     
      fd2client.status = 0; // set return command status
      i=0;//reset counter
      while (i < NumofCourses)
      { // while there are still course infomation
        if (Course[i].course == fd2server.courseid)
        { // courseid found
          if (fd2server.credits > 0)
          { // course credits is positive
            fd2client.status = 1; // set return command status
            Course[i].credits = fd2server.credits;
          };
          break; // break out of loop, no need to check any further, course is found
        }; 
        i++; // increment counter
      };//end of loop
    }
    else if (strcmp(fd2server.cmd, cGSCH) == 0) 
    { // gsch 
fprintf(stderr, " %d ", fd2server.courseid);        
      fd2client.status = 0; // set return command status
      strcpy(fd2client.returnstr, cERR); // return string
      i=0;//reset counter
      while (i < NumofCourses)
      { // while there are still course infomation
        if (Course[i].course == fd2server.courseid)
        { // courseid found
          strcpy(fd2client.returnstr, Course[i].courseinfo); // return course infomation
          break; // break out of loop, no need to check any further, course is found
        }; 
        i++; // increment counter
      };//end of loop
    }
    else if (strcmp(fd2server.cmd, cGCRE) == 0)
    { // gcre 
fprintf(stderr, " %d ", fd2server.courseid);    
      fd2client.status = 0; // set return command status
      if ( ( fd2client.returnint = getcoursecredit(fd2server.courseid) ) > -1)
      { // course is found, the number of credits is saved to return value
        fd2client.status = 1; // set return command status
      };
    }
    else
    { // invalid command
      fd2client.status = 0; // set return command status
      strcpy(fd2client.returnstr, cERR); // return string
    };
    // writing reply
    fd2client.seq = command_nmbr; // sequence number
    strcpy(fd2client.cmd, fd2server.cmd); // command received
    command_nmbr++;
    write(cltfd, &fd2client, sizeof( struct returnfifodata ) ); // write fifo
fprintf(stderr, " \n ");
    ;
  };
}


void printdb (char * filename)
{
  FILE * ffinaldb; // pointer to final database
  
  int i; // counters
  pNode pCurrent = NULL; // pointer to current node in linked list
  pNode pPrev = NULL; //pointer to previous node in linked list
  
  // opening the final database file 
  if ( ( ffinaldb = fopen(filename, "w")) == NULL ) 
  {   // open failed 
    fprintf(stderr, "Server: Could not open file '%s' for writing. \n", filename); // prints error message
    fatal_exit(); // close all fifos and error msg
    exit(1); // exit due to failure in opening the file 
  }; // open sucessful
  
  fprintf( ffinaldb, "%d ", NumofStudents); // print the number of students
  fprintf( ffinaldb, "\n"); // newline
  i=0; //reset counter
  while (i < NumofStudents)
  {// while there are still students to print
    fprintf( ffinaldb, "%s ", Student[i].name ); // print student name
    fprintf( ffinaldb, "%d ", Student[i].numcourse ); // print number of courses
    if (Student[i].first == NULL) // if first node is NULL
      pCurrent=NULL; // no nodes exist
    else
    { // nodes exists
      pCurrent=Student[i].first; // set pointer to first node in linked list
      pPrev = NULL; // pPrev == NULL, meaning this is the first node
    };
    while (pCurrent!=NULL)
    { // there are nodes that exists
      fprintf( ffinaldb, "%d ", pCurrent->coursenum ); // print course number
      pPrev=pCurrent; // prev pointer = current pointer
      if (pCurrent->next != NULL) // if next node exists
        pCurrent = pCurrent->next; // next is current node
      else
        pCurrent = NULL; // no more nodes
      free(pPrev); // free the current node
    }; // end of free nodes, memory returned
    fprintf( ffinaldb, "\n"); // newline
    i++; // increment counter for student table
  }; // finish printing student info
  
  fprintf( ffinaldb, "%d ", NumofCourses); // print the number of courses
  fprintf( ffinaldb, "\n"); // newline
  i=0;
  while (i < NumofCourses)
  { // while there are still course infomation to be read
    fprintf( ffinaldb, "%d ", Course[i].course ); // print course number
    fprintf( ffinaldb, "%d ", Course[i].credits ); // print number of enrolled
    fprintf( ffinaldb, "%s ", Course[i].courseinfo ); // print course infomation
    fprintf( ffinaldb, "\n"); // newline
    i++; // increment counter for course table  
  };
  
  fclose(ffinaldb); // close the final database file
}

