/*
Victor Ng
vn6216@albany.edu
csi402 Spring 2006

*/


#include <stdio.h>
#include <stdlib.h>

#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h> 
#include <fcntl.h>
#include <errno.h>

#include "bsconsts.h"
#include "bcstructs.h" //fifo struct
#include "bcglobs.h"
#include "bcprotos.h"

//  #include "bfunctions.c"

// used for command line comparison


int main(int argc, char *argv[]) 
{
  FILE * cmdfile; // pointer to initial database
  FILE * logfile; // pointer to final database
  
  // checking for parameters
  if( argc == NUMARGc )
    ;
  else // (should not happen, if this happens, check server file) parameter count is wrong
  {   // number of arguments or commands are not correct 
    fprintf(stderr, "Client: Invalid number of arguments. \n" );  // prints error message 
    exit(1); // exit due to incorrect number of arguments 
  };
  // create the fifo to client
  if (mkfifo(fifoclt, FIFO_MODE) == -1)
  {
    if (errno != EEXIST)
    { 
    fprintf(stderr, "Server: Couldn't create fifo to Client. Fatal Error. (try again) \n"); // prints error message 
    exit(1); // exit due to error in creating fifo
    }
  }; // fifo created sucessfully
  // open fifo to client
  if((cltfd = open(fifoclt, O_RDWR))==-1)
  { // filed in opening fifo write to client
    fprintf(stderr, "Client: fifo to client open read failed. Fatal Error. (try again) \n"); // prints error message 
    exit(1); // exit due to error in opening fifo
  }; // fifo opened sucessfully
  // open fifo to server
  if((cmdfd = open(fifocmd, O_WRONLY /* | O_NONBLOCK */ ))==-1)
  { // filed in opening fifo read to server
    fprintf(stderr, "Client: fifo to server open write failed. Fatal Error. (try again) \n"); // prints error message 
    exit(1); // exit due to error in opening fifo
  };// fifo opened sucessfully
  
    // opening the command file 
  if ( (cmdfile = fopen(argv[1], "r")) == NULL ) 
  {   // open failed 
    fprintf(stderr, "Client: Could not open file '%s' for reading. \n", argv[1]); // prints error message 
    fd2server.exit = 1; // setting exit = 1
    fatal_exit(); // close all fifos and error msg
    exit(1); // exit due to failure in opening the file 
  }; // open sucessful
  // opening the log file 
  if ( (logfile = fopen(argv[2], "w")) == NULL ) 
  {   // open failed 
    fprintf(stderr, "Client: Could not open file '%s' for writing. \n", argv[2]); // prints error message 
    fatal_exit(); // close all fifos and error msg
    exit(1); // exit due to failure in opening the file 
  }; // open sucessful
  
  

// start program
  processcmd (cmdfile, logfile);

// close files
  fclose(cmdfile);
  fclose(logfile);

  printf("Client: Process sucessful, exiting normally. \n");// exit confirm message
  unlink(fifocmd); // unlink
  unlink(fifoclt); // unlink
  
  return 0; // end of program
};
