/*
Victor Ng
vn6216@albany.edu
csi402 Spring 2006

*/


#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h> 
#include <fcntl.h>
#include <errno.h>

#include "bsconsts.h"
#include "bsstructs.h"
#include "bcstructs.h" //fifo struct
#include "bsglobs.h"
#include "bsprotos.h"

//  #include "bsfuncts.c"

// used for command line comparison
static const char * cClient = "p4b_client"; // client executible name

int main(int argc, char *argv[]) 
{  
  pid_t child; // pid
  struct stat statbuf; // stat buffer
  int nr; // number of bytes read
  
  // checking for parameters
  if( argc == NUMARG )
    ;
  else
  {   // number of arguments or commands are not correct 
    fprintf(stderr, "Server: Invalid number of arguments. \n" );  // prints error message 
    exit(1); // exit due to incorrect number of arguments 
  };

// fork process
  if ((child = fork()) == 0)
  { // this is child process
    execlp(cClient, cClient, argv[3], argv[4], NULL); 
    // execute the client on the child process
    // error if reached
    fprintf(stderr, "Child process could not do execvp. \n"); // prints error message 
    fd2server.exit = 1; // setting exit = 1
    if( (write(cmdfd, &fd2server, sizeof( struct cmdfifodata)) == -1) )// writing fifo to server
        fprintf(stderr, "Child: Cannot write fifo, send exit failed. \n"); // write failed
    exit(1); // exit do to failure to execvp
  }
  else
  { // this is parent process
    if (child == (pid_t) (-1) )
    {
      fprintf(stderr, "Fork failed.\n");
      fd2server.exit = 1; // setting exit = 1
      if( (write(cmdfd, &fd2server, sizeof( struct cmdfifodata)) == -1) )// writing fifo to server
        fprintf(stderr, "Child: Cannot write fifo, send exit failed. \n"); // write failed
      exit(1); // exit due to failure to fork
    };
  };// end of fork process
// parent process

// create the fifo to server
  if (mkfifo(fifocmd, FIFO_MODE) == -1)
  {
    if (errno != EEXIST)
    { 
    fprintf(stderr, "Server: Couldn't create fifo to Server. Fatal Error. (try again) \n"); // prints error message 
    exit(1); // exit due to error in creating fifo
    }
  };// fifo created sucessfully
// open fifo to server
  if((cmdfd = open(fifocmd, O_RDWR))==-1)
  { // filed in opening fifo read to server
    fprintf(stderr, "Server: fifo to server open read failed.  Fatal Error. (try again) \n"); // prints error message 
    exit(1); // exit due to error in opening fifo
  };// fifo opened sucessfully
  sleep(1); // wait for client to catch up
// open fifo to client
  if((cltfd = open(fifoclt, O_WRONLY /* | O_NONBLOCK */))==-1)
  { // filed in opening fifo write to client
    fprintf(stderr, "Server: fifo to client open write failed. Fatal Error. (try again) \n"); // prints error message 
    exit(1); // exit due to error in opening fifo
  }; // fifo opened sucessfully

// filecheck
  if(stat(argv[1],&statbuf) == -1)
  { // stat filed
    fprintf(stderr, "Server: file '%s' does not exists. \n", argv[1]);  // prints error message 
    fatal_exit(); // close all fifos and error msg
    exit(1); // exit
  }; // file stat sucessful
/*  if(stat(argv[2],&statbuf) == -1)
  { // stat filed
    fprintf(stderr, "Server: file '%s' does not exists. \n", argv[2]);  // prints error message 
    fatal_exit(); // close all fifos and error msg
    exit(1); // exit
  }; // file stat sucessful
*/
// read the initial database
  readdb (argv[1]); //read
  do
  {// loop till exit is sent
    while( (nr = read(cmdfd, &fd2server, sizeof( struct cmdfifodata ))) == 0);
    // keep reading till something is read
    if ( (nr == -1) || (nr!=sizeof( struct cmdfifodata ) ) )
    {
      fprintf(stderr, "Server: Read fifo filed.\n"); // read failed
      fatal_exit(); // close all fifos and error msg
      exit(1); // exit due to failure in reading command from client 
    }; // command received sucessfully
    
// process the fifo
    if (fd2server.exit != 1)
      processfifo(); // process
    else break;

  }while(fd2server.exit != 1); // end of loop
  //exit received, exit

// print the database    
  printdb (argv[2]); //write
  
  printf("Server: Process sucessful, exiting normally. \n"); // exit confirm message
  unlink(fifocmd); // unlink
  unlink(fifoclt); // unlink
  
  return 0; // end of program
};
